#include "collisio.h"

/*********************************************************************************************/
/******                 FONCTION DE GESTION DES COLLISIONS DE LA BALLE                  ******/
/******                 ----------------------------------------------                  ******/
/******    Ici c'est une partie un peu complique et assez abstraite...                 ******/
/******    Les collisions entre la balle et les murs sont assez simples  grer.        ******/
/******    Par contre les collisions entre la balle et les palettes en mouvement sont   ******/
/******    assez fastidieuses  programmer car il y a des tas de choses  penser en     ******/
/******    mme temps et des bugs inattendus surgissent souvent de nulle part...        ******/
/******    J'ai utilis comme principe de base les triangles semblables pour mieux      ******/
/******    prvoir les cas particuliers et pour les collisions horizontales ca marche   ******/
/******    franchement assez bien mais dans le cas des collisions verticales (sur les   ******/
/******    coins des palettes) j'ai du jouer avec des cas particuliers et mettre deux   ******/
/******    valeurs arbitraires dans les conditions pour que ca donne un bon rsultat.   ******/
/******    En fait la majorit des problmes viennent du fait que si la palette se      ******/
/******    dplace verticalement dans le sens oppos  la balle, la balle pourrait se   ******/
/******    retrouve coince dans la palette ce qui buggerait...                        ******/
/******                                                                                 ******/
/******    Malgr ca, des petits bugs sont apparus et ils ont t corrigs en rajoutant ******/
/******    des conditions compliques par ci par l jusqu' ce que ca marche...  Dsol ******/
/******    si cette partie du code est compltement illisible mais ca marche alors j'ai ******/
/******    peur d'aller retoucher.                                                      ******/
/******                                                                                 ******/
/******    En conclusion j'ai russi  faire des collisions assez ralistes et qui      ******/
/******    sont normalement fonctionnelles quel que soit la vitesse de la balle...      ******/
/******                                                                                 ******/
/******    j'ai utilis la librairie FMOD pour lire des fichiers wav avec la fonction   ******/
/******    PlaySound.  Cette librairie est thoriquement portable donc le jeu pourra    ******/
/******    facilement tre portable sur d'autres plateformes.                           ******/
/******                                                                                 ******/
/******    Un effet d'acclration sur l'axe y est donn  la balle si la palette est   ******/
/******    en mouvement au moment de l'impact.                                          ******/
/******                                                                                 ******/
/******    Pour donner un effet continu  la balle, si la prochaine position est prvue ******/
/******    aprs un mur ou une palette, elle rapparaitra  une distance du mur ou de la******/
/******    palette quivalente  ce que la balle aurait dpass le mur si ele avait.    ******/
/******    continu                                                                     ******/
/******                                                                                 ******/
/******    En parallle, cette fonction gre les scores ou les points en fonction du    ******/
/******    mode de jeu slectionn                                                      ******/
/******                                                                                 ******/
/*********************************************************************************************/

void collisions()
{
	/* si la prochaine position en x de la balle est au dela du mur de droite */
	if(ballex+10+ballevx>300 && mode==2)
	{
		if(pasbruitage==0)Mix_PlayChannel(-1, son_4, 0);
		ballex=300-(ballex+ballevx+10-300)-10;
		ballevx=-ballevx;

		if(mode==2)
		{
			i=atoi(score01)+2*(vabs((int)ballevx)+vabs((int)ballevy));
			sprintf(score01, "%d", i);
		}
	}

	/* Rafistollage pour contrer bug palette de droite */
	else if( ((palettedy+palettedvy+50<225 && palettedy+palettedvy+50>190 && balley+ballevy>120) || (palettedy+palettedvy-50>-225 && palettedy+palettedvy-50<-190 && balley+ballevy<-120)) && ballex+10<=300 && ballex+ballevx+10>300)
	{
		if(pasbruitage==0)Mix_PlayChannel(-1, son_4, 0);
		ballex=300-(ballex+ballevx+10-300)-10;
		ballevx=-ballevx;
		ballevy=ballevy+palettedvy/8;
	}

	/* sinon si la prochaine position en x de la balle est au dela de la palette de droite en passant par celle ci */
	else if((mode==3 || mode==4) && ( ballex+10<=300 && ballex+ballevx+10>300 && ((ballex+ballevx-300)/(300-ballex))*(palettedy+50-(balley-8)) >= balley+ballevy-8-(palettedy+palettedvy+50) && ((ballex+ballevx-300)/(300-ballex))*(palettedy-50-(balley+8)) <= balley+ballevy+8-(palettedy+palettedvy-50) ))
	{
		if(pasbruitage==0)Mix_PlayChannel(-1, son_4, 0);
		ballex=300-(ballex+ballevx+10-300)-10;
		ballevx=-ballevx;
		ballevy=ballevy+palettedvy/8;
	}

	/* Rafistollage pour contrer bug palette de gauche */
	else if( ((palettegy+palettegvy+50<225 && palettegy+palettegvy+50>190 && balley+ballevy>120) || (palettegy+palettegvy-50>-225 && palettegy+palettegvy-50<-190 && balley+ballevy<-120)) && ballex-10>=-300 && ballex+ballevx-10<-300)
	{
		if(pasbruitage==0)Mix_PlayChannel(-1, son_4, 0);
		ballex=-300-(ballex+ballevx-10+300)+10;
		ballevx=-ballevx;
		ballevy=ballevy+palettegvy/8;

		if(mode==2)
		{
			i=atoi(score01)+4*(vabs((int)ballevx)+vabs((int)ballevy));
			sprintf(score01, "%d", i);
		}
	}

	/* sinon si la prochaine position en x de la balle est au dela de la palette de gauche en passant par celle ci */
	else if( ballex-10>=-300 && ballex+ballevx-10<-300 && ((ballex+ballevx+300)/(-300-ballex))*(palettegy+50-(balley-8)) >= balley+ballevy-8-(palettegy+palettegvy+50) && ((ballex+ballevx+300)/(-300-ballex))*(palettegy-50-(balley+8)) <= balley+ballevy+8-(palettegy+palettegvy-50) )
	{
		if(pasbruitage==0)Mix_PlayChannel(-1, son_4, 0);
		ballex=-300-(ballex+ballevx-10+300)+10;
		ballevx=-ballevx;
		ballevy=ballevy+palettegvy/8;

		if(mode==2)
		{
			i=atoi(score01)+4*(vabs((int)ballevx)+vabs((int)ballevy));
			sprintf(score01, "%d", i);
		}
	}

	/* sinon (donc pas d'impact) */
	else
	{
		ballex=ballex+ballevx;
	}

	/* si la prochaine position en y de la balle est au dela du mur du haut */
	if(balley+10<=220 && balley+10+ballevy>220 && ballex+10>-320 && ballex-10<320)
	{
		if(pasbruitage==0)Mix_PlayChannel(-1, son_4, 0);
		balley=220-(balley+ballevy+10-220)-10;
		ballevy=-ballevy;

		if(mode==2)
		{
			i=atoi(score01)+3*(vabs((int)ballevx)+vabs((int)ballevy));
			sprintf(score01, "%d", i);
		}
	}

	/* sinon si la prochaine position en y de la balle est au dela du mur du bas */
	else if(balley-10>=-220 && balley-10+ballevy<-220 && ballex+10>-320 && ballex-10<320)
	{
		if(pasbruitage==0)Mix_PlayChannel(-1, son_4, 0);
		balley=-220-(balley+ballevy-10+220)+10;
		ballevy=-ballevy;

		if(mode==2)
		{
			i=atoi(score01)+3*(vabs((int)ballevx)+vabs((int)ballevy));
			sprintf(score01, "%d", i);
		}
	}

	/* sinon si la prochaine position en y de la balle est au dea du haut de la palette de gauche en passant par celle ci */
	else if(balley-10>=palettegy+50 && balley-10+ballevy<palettegy+50+palettegvy && (( ((balley+ballevy-(palettegy+50+palettegvy))/(palettegy+palettegvy+50-balley))*(-300-(ballex+10))	> ballex+ballevx+10+300	&& ((balley+ballevy-(palettegy+50+palettegvy))/(palettegy+palettegvy+50-balley))*(-310-(ballex+30))	< ballex+ballevx+30+310	) || (ballex+ballevx+10>=-310 && ballex+ballevx-10<=-300) )	)
	{
		if(pasbruitage==0)Mix_PlayChannel(-1, son_4, 0);
		balley=palettegy+palettegvy+50-(balley+ballevy-10-(palettegy+palettegvy+50))+10;
		ballevy=-ballevy;
		ballevy=ballevy+palettegvy;

		if(mode==2)
		{
			i=atoi(score01)+5*(vabs((int)ballevx)+vabs((int)ballevy));
			sprintf(score01, "%d", i);
		}
	}

	/* sinon si la prochaine position en y de la balle est au dea du haut de la palette de droite en passant par celle ci */
	else if((mode==3 || mode==4) && (balley-10>=palettedy+50 && balley-10+ballevy<palettedy+50+palettedvy && (( ((balley+ballevy-(palettedy+50+palettedvy))/(palettedy+palettedvy+50-balley))*(300-(ballex-10))	> ballex+ballevx-10-300	&& ((balley+ballevy-(palettedy+50+palettedvy))/(palettedy+palettedvy+50-balley))*(310-(ballex-30))	< ballex+ballevx-30-310	) || (ballex+ballevx-10<=310 && ballex+ballevx+10>=300) )	))
	{
		if(pasbruitage==0)Mix_PlayChannel(-1, son_4, 0);
		balley=palettedy+palettedvy+50-(balley+ballevy-10-(palettedy+palettedvy+50))+10;
		ballevy=-ballevy;
		ballevy=ballevy+palettedvy;
	}

	/* sinon si la prochaine position en y de la balle est au dea du bas de la palette de gauche en passant par celle ci */
	else if(balley+10<palettegy-50 && balley+10+ballevy>=palettegy-50+palettegvy && (( ((balley+ballevy-(palettegy-50+palettegvy))/(palettegy+palettegvy-50-balley))*(-300-(ballex+10))	< ballex+ballevx+10+300	&& ((balley+ballevy-(palettegy-50+palettegvy))/(palettegy+palettegvy-50-balley))*(-310-(ballex+30))	> ballex+ballevx+30+310	) || (ballex+ballevx+10>=-310 && ballex+ballevx-10<=-300) )	)
	{
		if(pasbruitage==0)Mix_PlayChannel(-1, son_4, 0);
		balley=palettegy+palettegvy-50-(balley+ballevy+10-(palettegy+palettegvy-50))-10;
		ballevy=-ballevy;
		ballevy=ballevy+palettegvy;

		if(mode==2)
		{
			i=atoi(score01)+5*(vabs((int)ballevx)+vabs((int)ballevy));
			sprintf(score01, "%d", i);
		}
	}

	/* sinon si la prochaine position en y de la balle est au dea du bas de la palette de droite en passant par celle ci */
	else if((mode==3 || mode==4) && (balley+10<palettedy-50 && balley+10+ballevy>=palettedy-50+palettedvy && (( ((balley+ballevy-(palettedy-50+palettedvy))/(palettedy+palettedvy-50-balley))*(300-(ballex-10)) < ballex+ballevx-10-300	&& ((balley+ballevy-(palettedy-50+palettedvy))/(palettedy+palettedvy-50-balley))*(310-(ballex-30)) > ballex+ballevx-30-310	) || (ballex+ballevx-10<=310 && ballex+ballevx+10>=300) )	))
	{
		if(pasbruitage==0)Mix_PlayChannel(-1, son_4, 0);
		balley=palettedy+palettedvy-50-(balley+ballevy+10-(palettedy+palettedvy-50))-10;
		ballevy=-ballevy;
		ballevy=ballevy+palettedvy;
	}

	/* sinon (donc pas d'impact) */
	else
	{
		balley=balley+ballevy;
	}

	/* Si la position en x a dpass une certaine limite  gauche */
	if(ballex>=-420 && ballex+ballevx<-420)
	{
		ballex=0;balley=0;ballevx=0;ballevy=0;
		if(mouv==2)
		{
			arret=0;
			mouv=1;
			if(pasbruitage==0)Mix_PlayChannel(-1, son_fly, 0);
		}
		else if(mouv==1 || mouv==4 || mouv==0)
		{
			arret=0;
			mouv=3;
			if(pasbruitage==0)Mix_PlayChannel(-1, son_fly, 0);
		}
		else if(mode!=2)
		{
			points--;
			if(points!=6 && points!=0)j=0;
			if(pasbruitage==0)Mix_PlayChannel(-1, son_5, 0);
		}

		if(mode==2)
		{
			i=atoi(score01);
			if(i>atoi(meilleurscore01))
			{
				sprintf(meilleurscore03, "%d", atoi(meilleurscore02));
				sprintf(meilleurscore02, "%d", atoi(meilleurscore01));
				sprintf(meilleurscore01, "%d", i);
			}
			else if(i>atoi(meilleurscore02))
			{
				sprintf(meilleurscore03, "%d", atoi(meilleurscore02));
				sprintf(meilleurscore02, "%d", i);
			}
			else if(i>atoi(meilleurscore03))
			{
				sprintf(meilleurscore03, "%d", i);
			}
			enregistrerfichier();
			j=0;
		}
	}
	/* Si la position en x a dpass une certaine limite  droite */
	else if(ballex<=420 && ballex+ballevx>420 && ((mode==3) || (mode==4)) )
	{
		ballex=0;balley=0;ballevx=0;ballevy=0;
		if(mouv==3)
		{
			arret=0;
			mouv=4;
			if(pasbruitage==0)Mix_PlayChannel(-1, son_fly, 0);
		}
		else if(mouv==1 || mouv==4 || mouv==0)
		{
			arret=0;
			mouv=2;
			if(pasbruitage==0)Mix_PlayChannel(-1, son_fly, 0);
		}
		else if(mode!=2)
		{
			if(pasbruitage==0)Mix_PlayChannel(-1, son_5, 0);
			points++;
			if(points!=6 && points!=0)j=0;
		}
	}
}

/***********************\FONCTION DE GESTION DES COLLISIONS DE LA BALLE***********************/
