#include "display.h"

/*********************************************************************************************/
/******                          FONCTION DU RENDU DE L'ECRAN                           ******/
/******                          ----------------------------                           ******/
/******    Cette fonction est srement la plus coriace et sert  gnrer tout ce qui va ******/
/******    tre affich  l'cran puis  afficher sur l'cran tout ce qui a t gnr. ******/
/******    glPolygonMode : sert  dfinir le mode d'affichage des polygones             ******/
/******                    (fil de fer, surfaces pleines, points)                       ******/
/******    glClearColor : dfini la couleur de remplissage par dfaut.                  ******/
/******    glClear : vide le buffer de couleur et le buffer de profondeur avec la       ******/
/******              couleur par dfaut.                                                ******/
/******                                                                                 ******/
/******    Les grosses conditions ( if(mode==?) ) dfinissent si c'est le menu ou le jeu******/
/******    qui doit tre affich, o quel type de jeu (1 joueurs, 2 joueurs etc...).    ******/
/******                                                                                 ******/
/******    Les conditions juste en dessous du mode==1 servent  dcider quel menu est   ******/
/******    actuellement actif et l'affiche  l'cran en donnant des repres  la souris ******/
/******    en fonction.                                                                 ******/
/******                                                                                 ******/
/******    Et les conditions encore  dessous ( if(sourisx...) ) dcident des zones     ******/
/******    sensibles de la souris et leur donne un certain numro (choix=??) pour que,  ******/
/******    si jamais elles sont cliques, la fonction de clic sache ce qu'elle doit     ******/
/******    activer.                                                                     ******/
/******                                                                                 ******/
/******    Comme la fonction est assez grande, je vais mettre des commentaires          ******/
/******    directement dedans pour y voir plus clair.                                   ******/
/******                                                                                 ******/
/*********************************************************************************************/

void timerwindows()
{
#ifdef SWIN32
	/* prend en mmoire le temps en units "ticks" */
	QueryPerformanceCounter((LARGE_INTEGER *) &currentTime2);
	QueryPerformanceFrequency((LARGE_INTEGER *) &frequence);

	/* permet de calculer les fps */
	++fps;
	if(currentTime2-lastTime2>frequence)
	{
		lastTime2=currentTime2;
//		printf("fps : %d\n", (int)fps);
		fps=0;
	}

	/* Force le raffichage en fonction de la frquence si l'option le demande */
	if(vsync==1)
	{
		swapfini=0;
		while(swapfini==0)
		{
			QueryPerformanceCounter((LARGE_INTEGER *) &currentTime);
			if(currentTime-lastTime>frequence/refresh)
			{
				lastTime=currentTime;
				swapfini=1;
				glutSwapBuffers();
			}
		}
	}
	else
	{
		glutSwapBuffers();
	}
#endif
}

void timerlinux()
{
#ifdef SLINUX
	/* prend en mmoire le temps en secondes */
	clock_gettime(CLOCK_REALTIME, &currenttimet);
	currentTime2 = currenttimet.tv_sec + (double) currenttimet.tv_nsec / (double)BILLION;

	/* permet de calculer les fps */
	fps++;
	if(currentTime2 - lastTime2 > 1.)
	{
		lastTime2=currentTime2;
//		printf("fps : %d\n", fps);
		fps=0;
	}

	/* Force le raffichage en fonction de la frquence si l'option le demande */
	if(vsync==1)
	{
		swapfini=0;
		while(swapfini==0)
		{
			/* prend en mmoire le temps en secondes */
			clock_gettime(CLOCK_REALTIME, &currenttimet);
			currentTime = currenttimet.tv_sec + (double) currenttimet.tv_nsec / (double)BILLION;
			if(currentTime-lastTime>1./refresh)
			{
				lastTime=currentTime;
				swapfini=1;
				glutSwapBuffers();
			}
		}
	}
	else
	{
		glutSwapBuffers();
	}
#endif
}

void Display()
{
	/* En fonction de l'option dsire, affiche ou non l'image en mode filiaire. */
	if(fer==1 && mode!=1)glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	else if(fer==0 || mode==1)glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	/* Vide les tampons couleurs et profondeurs avec la couleur dsire. */
	glClearColor(0.10,0.10,0.10,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glColor3d(1,1,1);

	/* Mode==1 signifie que l'on se trouve dans les menus */
	if(mode==1)
	{
		/* Affichage de la texture de fond des menus */
		glEnable (GL_TEXTURE_2D);
		glBindTexture (GL_TEXTURE_2D, 2);

		glBegin(GL_QUADS);

		glTexCoord2i(0,0);
		glVertex2i(0,0);

		glTexCoord2i(1,0);
		glVertex2i(width,0);

		glTexCoord2i(1,1);
		glVertex2i(width,height);

		glTexCoord2i(0,1);
		glVertex2i(0,height);

		glEnd();

		/* Si options==1 alors affichage du menu options */
		if(options==1)
		{
			/* Affichage de la texture du menu options */
			if(reso==1 || reso==2) glBindTexture (GL_TEXTURE_2D, 15);
			else if(reso==3 || reso==4) glBindTexture (GL_TEXTURE_2D, 26);

			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2i(250*rapportx2,150*rapporty2);

			glTexCoord2i(1,0);
			glVertex2i(550*rapportx2,150*rapporty2);

			glTexCoord2i(1,1);
			glVertex2i(550*rapportx2,350*rapporty2);

			glTexCoord2i(0,1);
			glVertex2i(250*rapportx2,350*rapporty2);

			glEnd();

			/* Dfinition des zones sensibles de la souris */
			if(sourisx>=335*rapportx && sourisx<=351*rapportx && sourisy<=height-356*rapporty && sourisy>=height-370*rapporty)
			{
				choix=7;
				forme=1;
			}
			else if(sourisx>=335*rapportx && sourisx<=351*rapportx && sourisy<=height-377*rapporty && sourisy>=height-391*rapporty)
			{
				choix=8;
				forme=1;
			}
			else if(sourisx>=335*rapportx && sourisx<=351*rapportx && sourisy<=height-398*rapporty && sourisy>=height-412*rapporty)
			{
				choix=9;
				forme=1;
			}
			else if(sourisx>=335*rapportx && sourisx<=351*rapportx && sourisy<=height-418*rapporty && sourisy>=height-433*rapporty)
			{
				choix=10;
				forme=1;
			}
			else if(sourisx>=335*rapportx && sourisx<=351*rapportx && sourisy<=height-439*rapporty && sourisy>=height-454*rapporty)
			{
				choix=11;
				forme=1;
			}
			else if(sourisx>=335*rapportx && sourisx<=351*rapportx && sourisy<=height-458*rapporty && sourisy>=height-473*rapporty)
			{
				choix=20;
				forme=1;
			}
			else if(sourisx>=335*rapportx && sourisx<=351*rapportx && sourisy<=height-480*rapporty && sourisy>=height-495*rapporty)
			{
				choix=21;
				forme=1;
			}
			else if(sourisx>=335*rapportx && sourisx<=351*rapportx && sourisy<=height-499*rapporty && sourisy>=height-515*rapporty)
			{
				choix=22;
				forme=1;
			}
			else if(sourisx>=463*rapportx && sourisx<=557*rapportx && sourisy<=height-528*rapporty && sourisy>=height-561*rapporty)
			{
				choix=12;
				forme=1;
			}
			else
			{
				forme=0;
				choix=0;
			}

			/* Noircissage des cases "options" coches */
			glColor3f(0.05,0.05,0.05);
			glBegin(GL_QUADS);

			/* Synchronisation vertiale */
			if(sourisactive==1)
			{
				glVertex2i(335*rapportx,height-372*rapporty);
				glVertex2i(335*rapportx,height-356*rapporty);
				glVertex2i(351*rapportx,height-356*rapporty);
				glVertex2i(351*rapportx,height-372*rapporty);
			}

			/* Fil de fer */
			if(fer==1)
			{
				glVertex2i(335*rapportx,height-392*rapporty);
				glVertex2i(335*rapportx,height-377*rapporty);
				glVertex2i(351*rapportx,height-377*rapporty);
				glVertex2i(351*rapportx,height-392*rapporty);
			}

			/* Acclration de la balle */
			if(accballe==1)
			{
				glVertex2i(335*rapportx,height-413*rapporty);
				glVertex2i(335*rapportx,height-398*rapporty);
				glVertex2i(351*rapportx,height-398*rapporty);
				glVertex2i(351*rapportx,height-413*rapporty);
			}

			/* Inertie des palettes */
			if(inertie==1)
			{
				glVertex2i(335*rapportx,height-433*rapporty);
				glVertex2i(335*rapportx,height-418*rapporty);
				glVertex2i(351*rapportx,height-418*rapporty);
				glVertex2i(351*rapportx,height-433*rapporty);
			}

			/* Rsolution de l'cran */
			if(reso_1024==1)
			{
				glVertex2i(335*rapportx,height-454*rapporty);
				glVertex2i(335*rapportx,height-439*rapporty);
				glVertex2i(351*rapportx,height-439*rapporty);
				glVertex2i(351*rapportx,height-454*rapporty);
			}

			/* Dsactivation de la musique */
			if(pasmusique==1)
			{
				glVertex2i(335*rapportx,height-474*rapporty);
				glVertex2i(335*rapportx,height-458*rapporty);
				glVertex2i(351*rapportx,height-458*rapporty);
				glVertex2i(351*rapportx,height-474*rapporty);
			}

			/* Dsactivation des bruitages */
			if(pasbruitage==1)
			{
				glVertex2i(335*rapportx,height-480*rapporty);
				glVertex2i(335*rapportx,height-495*rapporty);
				glVertex2i(351*rapportx,height-495*rapporty);
				glVertex2i(351*rapportx,height-480*rapporty);
			}

			/* Lancement de la balle par la barre d'espace */
			if(barredespace==1)
			{
				glVertex2i(335*rapportx,height-499*rapporty);
				glVertex2i(335*rapportx,height-515*rapporty);
				glVertex2i(351*rapportx,height-515*rapporty);
				glVertex2i(351*rapportx,height-499*rapporty);
			}

			glEnd();
		}

		/* Si credits==1 alors affichage du menu credits */
		else if(credits==1)
		{
			glBindTexture (GL_TEXTURE_2D, 16);

			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2i(250*rapportx2,150*rapporty2);

			glTexCoord2i(1,0);
			glVertex2i(550*rapportx2,150*rapporty2);

			glTexCoord2i(1,1);
			glVertex2i(550*rapportx2,350*rapporty2);

			glTexCoord2i(0,1);
			glVertex2i(250*rapportx2,350*rapporty2);

			glEnd();

			if(sourisx>=463*rapportx && sourisx<=557*rapportx && sourisy<=height-528*rapporty && sourisy>=height-561*rapporty)
			{
				choix=13;
				forme=1;
			}
			else
			{
				forme=0;
				choix=0;
			}
		}

		/* Si menuquit==1 alors affichage du menu de fin du jeu */
		else if(menuquit==1)
		{
			glBindTexture (GL_TEXTURE_2D, 17);

			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2i(250*rapportx2,150*rapporty2);

			glTexCoord2i(1,0);
			glVertex2i(550*rapportx2,150*rapporty2);

			glTexCoord2i(1,1);
			glVertex2i(550*rapportx2,350*rapporty2);

			glTexCoord2i(0,1);
			glVertex2i(250*rapportx2,350*rapporty2);

			glEnd();

			if(sourisx>=463*rapportx && sourisx<=557*rapportx && sourisy<=height-528*rapporty && sourisy>=height-561*rapporty)
			{
				choix=14;
				forme=1;
			}
			else
			{
				forme=0;
				choix=0;
			}
		}

		/* Si rseau==1 alors affichage du menu rseau */
		else if(reseau==1)
		{
#ifdef BLOCK_RESEAU
			glBindTexture (GL_TEXTURE_2D, 29);

			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2i(250*rapportx2,150*rapporty2);

			glTexCoord2i(1,0);
			glVertex2i(550*rapportx2,150*rapporty2);

			glTexCoord2i(1,1);
			glVertex2i(550*rapportx2,350*rapporty2);

			glTexCoord2i(0,1);
			glVertex2i(250*rapportx2,350*rapporty2);

			glEnd();
			
			if(sourisx>=463*rapportx && sourisx<=557*rapportx && sourisy<=height-528*rapporty && sourisy>=height-561*rapporty)
			{
				choix=23;
				forme=1;
			}
			else
			{
				forme=0;
				choix=0;
			}
#else
			glBindTexture (GL_TEXTURE_2D, 24);

			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2i(250*rapportx2,150*rapporty2);

			glTexCoord2i(1,0);
			glVertex2i(550*rapportx2,150*rapporty2);

			glTexCoord2i(1,1);
			glVertex2i(550*rapportx2,350*rapporty2);

			glTexCoord2i(0,1);
			glVertex2i(250*rapportx2,350*rapporty2);

			glEnd();

			/*gestion du pseudo*/

			glColor3d(0,0,0);
			afficher_texte(pseudo, 38*rapportx2, width/2, 270*rapportx2, 1, 1, 1);

			glColor3d(0,0,1);
			afficher_texte(pseudo, 38*rapportx2, width/2, 269*rapportx2, 2, 1, 1);

			glutKeyboardFunc(Touche2);

			/*fin de gestion du pseudo*/

			if(sourisx>=463*rapportx && sourisx<=557*rapportx && sourisy<=height-528*rapporty && sourisy>=height-561*rapporty)
			{
				choix=23;
				forme=1;
			}
			else
			{
				forme=0;
				choix=0;
			}
#endif
		}
		else if(menuip==1)
		{
			glBindTexture (GL_TEXTURE_2D, 28);

			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2i(250*rapportx2,150*rapporty2);

			glTexCoord2i(1,0);
			glVertex2i(550*rapportx2,150*rapporty2);

			glTexCoord2i(1,1);
			glVertex2i(550*rapportx2,350*rapporty2);

			glTexCoord2i(0,1);
			glVertex2i(250*rapportx2,350*rapporty2);

			glEnd();

			/*gestion de l'ip*/

			glColor3d(0,0,0);
			afficher_texte(ip, 31*rapportx2, width/2, 222*rapportx2, 1, 1, 1);

			glColor3d(0,0,1);
			afficher_texte(ip, 31*rapportx2, width/2, 222*rapportx2, 2, 1, 1);

			glutKeyboardFunc(Touche3);

			/*fin de gestion de l'ip*/

			if(sourisx>=440*rapportx && sourisx<=579*rapportx && sourisy<=height-531*rapporty && sourisy>=height-563*rapporty)
			{
				choix=25;
				forme=1;
			}
			else if(sourisx>=440*rapportx && sourisx<=579*rapportx && sourisy<=height-377*rapporty && sourisy>=height-409*rapporty)
			{
				choix=25;
				forme=1;
			}
			else
			{
				forme=0;
				choix=0;
			}
		}

		/* Si menudifficulte==1 alors affichage de la selection de la difficult */
		else if(menudifficulte==1)
		{
			glBindTexture (GL_TEXTURE_2D, 18);

			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2i(250*rapportx2,150*rapporty2);

			glTexCoord2i(1,0);
			glVertex2i(550*rapportx2,150*rapporty2);

			glTexCoord2i(1,1);
			glVertex2i(550*rapportx2,350*rapporty2);

			glTexCoord2i(0,1);
			glVertex2i(250*rapportx2,350*rapporty2);

			glEnd();

			/* Si la souris est sur le premier niveau de difficult */
			if(sourisx>=285*rapportx2 && sourisx<=515*rapportx2 && sourisy<=height-270*rapporty2 && sourisy>=height-292*rapporty2)
			{
				choix=15;
				forme=1;

				/* Affichage des smilies */
				glBindTexture (GL_TEXTURE_2D, 19);

				glBegin(GL_QUADS);

				glTexCoord2i(0,0);
				glVertex2i(380*rapportx2,155*rapporty2);

				glTexCoord2i(1,0);
				glVertex2i(420*rapportx2,155*rapporty2);

				glTexCoord2i(1,1);
				glVertex2i(420*rapportx2,195*rapporty2);

				glTexCoord2i(0,1);
				glVertex2i(380*rapportx2,195*rapporty2);

				glEnd();

				/* Affichage du nombre de victoires qui va  cot du smiley */
				glColor3d(0,0,0);
				glDisable(GL_TEXTURE_2D);
				glRasterPos2f(260*rapportx2,178*rapporty2);
				largeur2=0;
				for(i=0;i<9;i++)
				{
					glutBitmapCharacter(GLUT_BITMAP_9_BY_15,victoire[i]);
					largeur2=largeur2+glutBitmapWidth(GLUT_BITMAP_9_BY_15,victoire[i]);
				}
				largeur3=0;
				for(i=0;i<strlen(victoire01);i++)
				{
					largeur3=largeur3+glutBitmapWidth(GLUT_BITMAP_9_BY_15,victoire01[i]);
				}
				glRasterPos2f(260*rapportx2+largeur2/2-largeur3/2,160*rapporty2);
				for(i=0;i<strlen(victoire01);i++)
				{
					glutBitmapCharacter(GLUT_BITMAP_9_BY_15,victoire01[i]);
				}
				glEnable(GL_TEXTURE_2D);
				glColor3d(1,1,1);
			}

			/* Si la souris est sur le deuxime niveau de difficult */
			else if(sourisx>=285*rapportx2 && sourisx<=515*rapportx2 && sourisy<=height-297*rapporty2 && sourisy>=height-319*rapporty2)
			{
				choix=16;
				forme=1;

				/* Affichage des smilies */
				glBindTexture (GL_TEXTURE_2D, 20);

				glBegin(GL_QUADS);

				glTexCoord2i(0,0);
				glVertex2i(380*rapportx2,155*rapporty2);

				glTexCoord2i(1,0);
				glVertex2i(420*rapportx2,155*rapporty2);

				glTexCoord2i(1,1);
				glVertex2i(420*rapportx2,195*rapporty2);

				glTexCoord2i(0,1);
				glVertex2i(380*rapportx2,195*rapporty2);

				glEnd();

				/* Affichage du nombre de victoires qui va  cot du smiley */
				glColor3d(0,0,0);
				glDisable(GL_TEXTURE_2D);
				glRasterPos2f(260*rapportx2,178*rapporty2);
				largeur2=0;
				for(i=0;i<9;i++)
				{
					glutBitmapCharacter(GLUT_BITMAP_9_BY_15,victoire[i]);
					largeur2=largeur2+glutBitmapWidth(GLUT_BITMAP_9_BY_15,victoire[i]);
				}
				largeur3=0;
				for(i=0;i<strlen(victoire02);i++)
				{
					largeur3=largeur3+glutBitmapWidth(GLUT_BITMAP_9_BY_15,victoire02[i]);
				}
				glRasterPos2f(260*rapportx2+largeur2/2-largeur3/2,160*rapporty2);
				for(i=0;i<strlen(victoire02);i++)
				{
					glutBitmapCharacter(GLUT_BITMAP_9_BY_15,victoire02[i]);
				}
				glEnable(GL_TEXTURE_2D);
				glColor3d(1,1,1);
			}

			/* Si la souris est sur le troisime niveau de difficult */
			else if(sourisx>=285*rapportx2 && sourisx<=515*rapportx2 && sourisy<=height-324*rapporty2 && sourisy>=height-346*rapporty2)
			{
				choix=17;
				forme=1;

				/* Affichage des smilies */
				glBindTexture (GL_TEXTURE_2D, 21);

				glBegin(GL_QUADS);

				glTexCoord2i(0,0);
				glVertex2i(380*rapportx2,155*rapporty2);

				glTexCoord2i(1,0);
				glVertex2i(420*rapportx2,155*rapporty2);

				glTexCoord2i(1,1);
				glVertex2i(420*rapportx2,195*rapporty2);

				glTexCoord2i(0,1);
				glVertex2i(380*rapportx2,195*rapporty2);

				glEnd();

				/* Affichage du nombre de victoires qui va  cot du smiley */
				glColor3d(0,0,0);
				glDisable(GL_TEXTURE_2D);
				glRasterPos2f(260*rapportx2,178*rapporty2);
				largeur2=0;
				for(i=0;i<9;i++)
				{
					glutBitmapCharacter(GLUT_BITMAP_9_BY_15,victoire[i]);
					largeur2=largeur2+glutBitmapWidth(GLUT_BITMAP_9_BY_15,victoire[i]);
				}
				largeur3=0;
				for(i=0;i<strlen(victoire03);i++)
				{
					largeur3=largeur3+glutBitmapWidth(GLUT_BITMAP_9_BY_15,victoire03[i]);
				}
				glRasterPos2f(260*rapportx2+largeur2/2-largeur3/2,160*rapporty2);
				for(i=0;i<strlen(victoire03);i++)
				{
					glutBitmapCharacter(GLUT_BITMAP_9_BY_15,victoire03[i]);
				}
				glEnable(GL_TEXTURE_2D);
				glColor3d(1,1,1);
			}

			/* Si la souris est sur le quatrime niveau de difficult */
			else if(sourisx>=285*rapportx2 && sourisx<=515*rapportx2 && sourisy<=height-352*rapporty2 && sourisy>=height-374*rapporty2)
			{
				choix=18;
				forme=1;

				/* Affichage des smilies */
				glBindTexture (GL_TEXTURE_2D, 22);

				glBegin(GL_QUADS);

				glTexCoord2i(0,0);
				glVertex2i(380*rapportx2,155*rapporty2);

				glTexCoord2i(1,0);
				glVertex2i(420*rapportx2,155*rapporty2);

				glTexCoord2i(1,1);
				glVertex2i(420*rapportx2,195*rapporty2);

				glTexCoord2i(0,1);
				glVertex2i(380*rapportx2,195*rapporty2);

				glEnd();

				/* Affichage du nombre de victoires qui va  cot du smiley */
				glColor3d(0,0,0);
				glDisable(GL_TEXTURE_2D);
				glRasterPos2f(260*rapportx2,178*rapporty2);
				largeur2=0;
				for(i=0;i<9;i++)
				{
					glutBitmapCharacter(GLUT_BITMAP_9_BY_15,victoire[i]);
					largeur2=largeur2+glutBitmapWidth(GLUT_BITMAP_9_BY_15,victoire[i]);
				}
				largeur3=0;
				for(i=0;i<strlen(victoire04);i++)
				{
					largeur3=largeur3+glutBitmapWidth(GLUT_BITMAP_9_BY_15,victoire04[i]);
				}
				glRasterPos2f(260*rapportx2+largeur2/2-largeur3/2,160*rapporty2);
				for(i=0;i<strlen(victoire04);i++)
				{
					glutBitmapCharacter(GLUT_BITMAP_9_BY_15,victoire04[i]);
				}
				glEnable(GL_TEXTURE_2D);
				glColor3d(1,1,1);
			}

			/* Si la souris est sur le cinquime niveau de difficult */
			else if(sourisx>=285*rapportx2 && sourisx<=515*rapportx2 && sourisy<=height-379*rapporty2 && sourisy>=height-401*rapporty2)
			{
				choix=19;
				forme=1;

				/* Affichage des smilies */
				glBindTexture (GL_TEXTURE_2D, 23);

				glBegin(GL_QUADS);

				glTexCoord2i(0,0);
				glVertex2i(380*rapportx2,155*rapporty2);

				glTexCoord2i(1,0);
				glVertex2i(420*rapportx2,155*rapporty2);

				glTexCoord2i(1,1);
				glVertex2i(420*rapportx2,195*rapporty2);

				glTexCoord2i(0,1);
				glVertex2i(380*rapportx2,195*rapporty2);

				glEnd();

				/* Affichage du nombre de victoires qui va  cot du smiley */
				glColor3d(0,0,0);
				glDisable(GL_TEXTURE_2D);
				glRasterPos2f(260*rapportx2,178*rapporty2);
				largeur2=0;
				for(i=0;i<9;i++)
				{
					glutBitmapCharacter(GLUT_BITMAP_9_BY_15,victoire[i]);
					largeur2=largeur2+glutBitmapWidth(GLUT_BITMAP_9_BY_15,victoire[i]);
				}
				largeur3=0;
				for(i=0;i<strlen(victoire05);i++)
				{
					largeur3=largeur3+glutBitmapWidth(GLUT_BITMAP_9_BY_15,victoire05[i]);
				}
				glRasterPos2f(260*rapportx2+largeur2/2-largeur3/2,160*rapporty2);
				for(i=0;i<strlen(victoire05);i++)
				{
					glutBitmapCharacter(GLUT_BITMAP_9_BY_15,victoire05[i]);
				}
				glEnable(GL_TEXTURE_2D);
				glColor3d(1,1,1);
			}
			else
			{
				forme=0;
				choix=0;
			}
		}

		/* Si aucun sous menu n'est activ */
		else
		{
			/* Dfinition de la sensibilit de la souris pour les choix principaux (1 joueur, 2 joueurs etc...) */
			if(sourisx>=34*rapportx && sourisx<=64*rapportx && sourisy<=height-348*rapporty && sourisy>=height-378*rapporty)
			{
				choix=1;
				forme=1;
			}
			else if(sourisx>=181*rapportx && sourisx<=211*rapportx && sourisy<=height-396*rapporty && sourisy>=height-425*rapporty)
			{
				choix=1;
				forme=1;
			}
			else if(sourisx>=181*rapportx && sourisx<=211*rapportx && sourisy<=height-439*rapporty && sourisy>=height-470*rapporty)
			{
				choix=2;
				forme=1;
			}
			else if(sourisx>=34*rapportx && sourisx<=64*rapportx && sourisy<=height-531*rapporty && sourisy>=height-563*rapporty)
			{
				choix=3;
				forme=1;
			}
			else if(sourisx>=181*rapportx && sourisx<=211*rapportx && sourisy<=height-577*rapporty && sourisy>=height-608*rapporty)
			{
				choix=3;
				forme=1;
			}
			else if(sourisx>=181*rapportx && sourisx<=211*rapportx && sourisy<=height-623*rapporty && sourisy>=height-654*rapporty)
			{
				choix=4;
				forme=1;
			}
			else if(sourisx>=45*rapportx && sourisx<=65*rapportx && sourisy<=height-689*rapporty && sourisy>=height-710*rapporty)
			{
				choix=5;
				forme=1;
			}
			else if(sourisx>=45*rapportx && sourisx<=65*rapportx && sourisy<=height-721*rapporty && sourisy>=height-740*rapporty)
			{
				choix=6;
				forme=1;
			}
			else if(sourisx>=903*rapportx && sourisx<=1024*rapportx && sourisy<=height-735*rapporty && sourisy>=height-768*rapporty)
			{
				choix=24;
				forme=1;
			}
			else if(sourisx>=840*rapportx && sourisx<=861*rapportx && sourisy<=height-301*rapporty && sourisy>=height-320*rapporty)
			{
				choix=35;
				forme=1;
			}
			else if(sourisx>=870*rapportx && sourisx<=893*rapportx && sourisy<=height-301*rapporty && sourisy>=height-320*rapporty)
			{
				choix=36;
				forme=1;
			}
			else
			{
				forme=0;
				choix=0;
			}
		}

		/* Noircissage des carrs selectionns par la souris */
		glColor3f(0.05,0.05,0.05);

		glBegin(GL_QUADS);

		if(choix == 24) // Quitter
		{
			if(selectperso != 7 && menuquit==0)
			{
				oldselectperso = selectperso;
				selectperso = 7;
				fade = 0.2;	
			}
		}
		else if(choix==1)
		{
			glVertex2i(34*rapportx,height-348*rapporty);	//
			glVertex2i(65*rapportx,height-348*rapporty);	// Un joueur
			glVertex2i(65*rapportx,height-378*rapporty);	//
			glVertex2i(34*rapportx,height-378*rapporty);	//

			glVertex2i(181*rapportx,height-396*rapporty);	//
			glVertex2i(212*rapportx,height-396*rapporty);	// Seul
			glVertex2i(212*rapportx,height-425*rapporty);	//
			glVertex2i(181*rapportx,height-425*rapporty);	//
		
			if(selectperso != 5 && menuquit==0)
			{
				oldselectperso = selectperso;
				selectperso = 5;
				fade = 0.2;	
			}
		}
		else if(choix==2)
		{
			glVertex2i(34*rapportx,height-348*rapporty);	//
			glVertex2i(65*rapportx,height-348*rapporty);	// Un joueur
			glVertex2i(65*rapportx,height-378*rapporty);	//
			glVertex2i(34*rapportx,height-378*rapporty);	//

			glVertex2i(181*rapportx,height-439*rapporty);	//
			glVertex2i(212*rapportx,height-439*rapporty);	// Contre pc
			glVertex2i(212*rapportx,height-470*rapporty);	//
			glVertex2i(181*rapportx,height-470*rapporty);	//
		
			if(selectperso != 5 && menuquit==0)
			{
				oldselectperso = selectperso;
				selectperso = 5;
				fade = 0.2;	
			}
		}
		else if(choix==3)
		{
			glVertex2i(34*rapportx,height-531*rapporty);	//
			glVertex2i(65*rapportx,height-531*rapporty);	// Deux joueurs
			glVertex2i(65*rapportx,height-563*rapporty);	//
			glVertex2i(34*rapportx,height-563*rapporty);	//

			glVertex2i(181*rapportx,height-577*rapporty);	//
			glVertex2i(212*rapportx,height-577*rapporty);	// Sur un pc
			glVertex2i(212*rapportx,height-608*rapporty);	//
			glVertex2i(181*rapportx,height-608*rapporty);	//
			
			if(selectperso != 3 && menuquit==0)
			{
				oldselectperso = selectperso;
				selectperso = 3;
				fade = 0.2;	
			}
		}
		else if(choix==4)
		{
			glVertex2i(34*rapportx,height-531*rapporty);	//
			glVertex2i(65*rapportx,height-531*rapporty);	// Deux joueurs
			glVertex2i(65*rapportx,height-563*rapporty);	//
			glVertex2i(34*rapportx,height-563*rapporty);	//

			glVertex2i(181*rapportx,height-623*rapporty);	//
			glVertex2i(212*rapportx,height-623*rapporty);	// En rseau
			glVertex2i(212*rapportx,height-654*rapporty);	//
			glVertex2i(181*rapportx,height-654*rapporty);	//
			
			if(selectperso != 3 && menuquit==0)
			{
				oldselectperso = selectperso;
				selectperso = 3;
				fade = 0.2;	
			}
		}
		else if(choix==5)
		{
			glVertex2i(45*rapportx,height-689*rapporty);	//
			glVertex2i(65*rapportx,height-689*rapporty);	// Options
			glVertex2i(65*rapportx,height-710*rapporty);	//
			glVertex2i(45*rapportx,height-710*rapporty);	//
		}
		else if(choix==6)
		{
			glVertex2i(45*rapportx,height-721*rapporty);	//
			glVertex2i(65*rapportx,height-721*rapporty);	// Crdits
			glVertex2i(65*rapportx,height-740*rapporty);	//
			glVertex2i(45*rapportx,height-740*rapporty);	//
		}
		else
		{
			if(selectperso != 1 && menuquit==0)
			{
				oldselectperso = selectperso;
				selectperso = 1;
				fade = 0.2;	
			}
		}
		glEnd();
		
		for(i=0;i<2;i++)
		{
			if(i==0)
			{
				glColor4d(1,1,1,1.0-1.25*fade);
				glBindTexture(GL_TEXTURE_2D, animperso[oldselectperso-1]);
			}
			else if(i==1)
			{
				glColor4d(1,1,1,fade);
				glBindTexture(GL_TEXTURE_2D, animperso[selectperso-1]);
			}
			
			glBegin(GL_QUADS);
	
			glTexCoord2f(0.0, 1.0);
			glVertex2i(650*rapportx,450*rapporty);
	
			glTexCoord2f(1.0, 1.0);
			glVertex2i(970*rapportx,450*rapporty);
	
			glTexCoord2f(1.0, 0.0);
			glVertex2i(970*rapportx, 15*rapporty);
	
			glTexCoord2f(0.0, 0.0);
			glVertex2i(650*rapportx, 15*rapporty);
	
			glEnd();
		}
		
		/* Choix de la texture de la souris en fonction de si elle est sur une zone sensible ou pas */
  		if(forme==0)
  		{
			glBindTexture (GL_TEXTURE_2D, 1);
			son=1;
		}
  		else if(forme==1)
  		{
			if(son==1)
			{
				if(pasbruitage==0)Mix_PlayChannel(-1, son_3, 0);
				son=0;
			}
			glBindTexture (GL_TEXTURE_2D, 3);
		}

		/* Dfinission de la zone d'affichage de la texture en fonction de la position de la souris */
		glBegin(GL_QUADS);

		glTexCoord2f(0.0, 1.0);
		glVertex2i(sourisx,sourisy);

		glTexCoord2f(1.0, 1.0);
		glVertex2i(sourisx+60*rapportx,sourisy);

		glTexCoord2f(1.0, 0.0);
		glVertex2i(sourisx+60*rapportx, sourisy-60*rapportx);

		glTexCoord2f(0.0, 0.0);
		glVertex2i(sourisx, sourisy-60*rapportx);

		glEnd();
		glDisable (GL_TEXTURE_2D);

	}

	/* Si le jeu est lanc (et donc ne plus s'occuper des menus) */
	else
	{
		glutWarpPointer(glutGet(GLUT_WINDOW_WIDTH)/2, glutGet(GLUT_WINDOW_HEIGHT)/2);
		
		/* Position de la camra en fonction des variables obtenues */
		gluLookAt(camx,camy,camz,0,0,0,vertx,verty,vertz);

		/* Dfinition du dcallage des contours vers la camra */
		glPolygonOffset(1, 1);

		glPushMatrix();
		decor();
		glPopMatrix();


		glPushMatrix();

		/* Fonction de dplacement appele en fonction des options choisies */
		if(inertie==1)deplacementpaletteg();
		else if(inertie==0)deplacementpaletteg2();
		affichagepaletteg();

		glPopMatrix();
		glPushMatrix();

		if(mode==4 || mode==3)
		{
			if(mode==3)
			{
				/* Choix de l'intelligence artificielle en fonction du niveau de difficult */
				if(choixia==1) ia1();
				else if(choixia==2) ia2();
				else if(choixia==3) ia3();
				else if(choixia==4) ia4();
				else if(choixia==5) ia5();
			}
//			if(inertie==1)
				deplacementpaletted();
//			else if(inertie==0)
//				deplacementpaletted2();
			affichagepaletted();
		}

		glPopMatrix();

		glPushMatrix();

		/* Si l'acclration de la balle est active dans les options, alors la balle est acclre ici */
		if(accballe==1)
		{
			if(ballevx>0)ballevx=ballevx+(float)0.002/refresh*85;
			if(ballevx<0)ballevx=ballevx-(float)0.002/refresh*85;
			if(ballevy>0)ballevy=ballevy+(float)0.002/refresh*85;
			if(ballevy<0)ballevy=ballevy-(float)0.002/refresh*85;
		}

		/* Appel de la fonction qui gre les collisions */
		collisions();

		/* Le dplacement des palettes est ici pris en compte (je me rend compte que ce n'est  */
		/* pas la position optimale pour le placer et que c'est srement  cause de a que ma  */
		/* fonction de collisions a d tre modifie bizarrement.  Mais maintenant tout marche */
		/* alors a ne sert  rien de changer.                                                 */
		palettegy=palettegy+palettegvy;

		if(mode==4 || mode==3)
		{
			palettedy=palettedy+palettedvy;
		}
		glPopMatrix();
		glPushMatrix();

		/* Dfini la position de la balle */
		glTranslatef(ballex,balley,ballez);

	    /* Dessin de la balle */
		rotballe=rotballe+(float)1/refresh*85;
		if(rotballe>=720) rotballe=0;

		glRotatef(rotballe,0,1,1);
		glColor3d(1,1,1);
		glutSolidSphere(9.9,10,10);
		glColor3d(0,0,0);
		glutWireSphere(10,7,4);

	    /* Dessin des grosses sphres */
		glLoadIdentity();
		glPopMatrix();
		glPushMatrix();
		glRotatef(90,0,1,0);

		glRotatef(rotballe/20,0,0,1);
		glColor3d(0.20,0.20,0.20);
		glutWireSphere(2500,20,12);
		glLoadIdentity();
		glPopMatrix();
		glPushMatrix();
		glRotatef(90,1,0,0);

		glRotatef(rotballe/20,0,0,1);
		glutWireSphere(10000,20,12);
		glLoadIdentity();
		glPopMatrix();
		glPushMatrix();

		glRotatef(90,-1,0,0);

		glRotatef(rotballe/20,0,0,1);
		glutWireSphere(10000,20,12);
		glColor3d(1,1,1);

		glPopMatrix();
		glPushMatrix();

		/* Si l'option est active, dfini l'affichage du compte  rebours */
		if(barredespace==0)
		{
			if(j>0)
			{
				glColor3d(1,0,0);
				if(mouv==3) glTranslatef(0,-60,50);
				else if(mouv==-1 || mouv==2) glTranslatef(0,60,50);
				else glTranslatef(-60,50,50);
				glutSolidSphere(15,10,10);
			}

			if(j==0 && pasbruitage==0) Mix_PlayChannel(-1, son_beep1, 0);

			if(j>40)
			{
				glColor3d(1,0.63,0);
				if(mouv==3) glTranslatef(0,60,0);
				else if(mouv==-1 || mouv==2) glTranslatef(0,-60,0);
				else glTranslatef(60,0,0);
				glutSolidSphere(15,10,10);
			}

			if(j==40 && pasbruitage==0) Mix_PlayChannel(-1, son_beep1, 0);

			if(j>80)
			{
				glColor3d(0,1,0);
				if(mouv==3) glTranslatef(0,60,0);
				else if(mouv==-1 || mouv==2) glTranslatef(0,-60,0);
				else glTranslatef(60,0,0);
				glutSolidSphere(15,10,10);
			}

			if(j==80 && pasbruitage==0) Mix_PlayChannel(-1, son_beep1, 0);

			if(j>120)
			{
				lancerballe();
				j=-1;
			}
			if (j>=0)j++;
		}
		glPopMatrix();

		/* Changement de perspective pour le mode 2d */
		glMatrixMode(GL_PROJECTION);
		glPushMatrix();
		glLoadIdentity();
		glOrtho(0,width,0,height,0,1);
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();

		/* Ce qui suit sera l'affichage du HUD */
		glColor3d(1,1,1);
		glDisable(GL_DEPTH_TEST);
		glEnable (GL_TEXTURE_2D);
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

		/* Affichage des jauges des scores */
		if(mode==3 || mode==4)
		{
			glBindTexture (GL_TEXTURE_2D, 4+points);

			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2d(50*rapportx2,560*rapporty2);

			glTexCoord2i(1,0);
			glVertex2d(300*rapportx2,560*rapporty2);

			glTexCoord2i(1,1);
			glVertex2d(300*rapportx2,600*rapporty2);

			glTexCoord2i(0,1);
			glVertex2d(50*rapportx2,600*rapporty2);

			glEnd();


			glBindTexture (GL_TEXTURE_2D, 4+(6-points));

			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2d(750*rapportx2,560*rapporty2);

			glTexCoord2i(1,0);
			glVertex2d(500*rapportx2,560*rapporty2);

			glTexCoord2i(1,1);
			glVertex2d(500*rapportx2,600*rapporty2);

			glTexCoord2i(0,1);
			glVertex2d(750*rapportx2,600*rapporty2);

			glEnd();
		}

		/* Affichage du titre "PonGL" */
		glBindTexture (GL_TEXTURE_2D, 11);
		glBegin(GL_QUADS);

		glTexCoord2i(0,0);
		glVertex2d(300*rapportx2,560*rapporty2);

		glTexCoord2i(1,0);
		glVertex2d(500*rapportx2,560*rapporty2);

		glTexCoord2i(1,1);
		glVertex2d(500*rapportx2,600*rapporty2);


		glTexCoord2i(0,1);
		glVertex2d(300*rapportx2,600*rapporty2);

		glEnd();


		/* Affichage de celui qui a l'avantage */
		if(mouv==2)
		{
			glBindTexture (GL_TEXTURE_2D, 12);
			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2d(0,560*rapporty2);

			glTexCoord2i(1,0);
			glVertex2d(50*rapportx2,560*rapporty2);

			glTexCoord2i(1,1);
			glVertex2d(50*rapportx2,600*rapporty2);

			glTexCoord2i(0,1);
			glVertex2d(0,600*rapporty2);

			glEnd();
		}
		else if(mouv==3)
		{
			glBindTexture (GL_TEXTURE_2D, 12);
			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2d(800*rapportx2,560*rapporty2);

			glTexCoord2i(1,0);
			glVertex2d(750*rapportx2,560*rapporty2);

			glTexCoord2i(1,1);
			glVertex2d(750*rapportx2,600*rapporty2);

			glTexCoord2i(0,1);
			glVertex2d(800*rapportx2,600*rapporty2);

			glEnd();
		}

		/* Cette fonction incrmente le nombre de victoires lorsque le pc est battu */
		if(points==6 || points==0)
		{
			if(points==6)
			{
				if(ajoutpoint==0)
				{
					if(choixia==1)
					{
						i=atoi(victoire01)+1;
						sprintf(victoire01, "%d", i);
					}
					else if(choixia==2)
					{
						i=atoi(victoire02)+1;
						sprintf(victoire02, "%d", i);
					}
					else if(choixia==3)
					{
						i=atoi(victoire03)+1;
						sprintf(victoire03, "%d", i);
					}
					else if(choixia==4)
					{
						i=atoi(victoire04)+1;
						sprintf(victoire04, "%d", i);
					}
					else if(choixia==5)
					{
						i=atoi(victoire05)+1;
						sprintf(victoire05, "%d", i);
					}
					ajoutpoint=1;
					enregistrerfichier();
				}
				glBindTexture (GL_TEXTURE_2D, 13);
			}

			/* Affiche que le joueur2 a gagn */
			else if(points==0)
			{
				glBindTexture (GL_TEXTURE_2D, 14);
			}
			glBegin(GL_QUADS);

			glTexCoord2i(0,0);
			glVertex2d(250*rapportx2,450*rapporty2);

			glTexCoord2i(1,0);
			glVertex2d(550*rapportx2,450*rapporty2);

			glTexCoord2i(1,1);
			glVertex2d(550*rapportx2,550*rapporty2);

			glTexCoord2i(0,1);
			glVertex2d(250*rapportx2,550*rapporty2);

			glEnd();
		}

		/* Affichage des scores pour le mode 1 joueur */
		if(mode==2)
		{
			glColor3d(1,1,1);
			glDisable(GL_TEXTURE_2D);

			glRasterPos2f(50*rapportx2,575*rapporty2);
			largeur2=0;
			for(i=0;i<strlen(score);i++)
			{
				glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24,score[i]);
				largeur2=largeur2+glutBitmapWidth(GLUT_BITMAP_TIMES_ROMAN_24,score[i]);
			}
			largeur3=0;
			for(i=0;i<strlen(score01);i++)
			{
				largeur3=largeur3+glutBitmapWidth(GLUT_BITMAP_TIMES_ROMAN_24,score01[i]);
			}
			glRasterPos2f(50*rapportx2+largeur2/2-largeur3/2,550*rapporty2);
			for(i=0;i<strlen(score01);i++)
			{
				glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24,score01[i]);
			}

			glRasterPos2f(585*rapportx2, 575*rapporty2);
	
			largeur2=0;
			for(i=0;i<strlen(meilleursscores);i++)
			{
				glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24,meilleursscores[i]);
				largeur2=largeur2+glutBitmapWidth(GLUT_BITMAP_TIMES_ROMAN_24,meilleursscores[i]);
			}

			largeur3=0;
			for(i=0;i<strlen(meilleurscore01);i++)
			{
				largeur3=largeur3+glutBitmapWidth(GLUT_BITMAP_TIMES_ROMAN_24,meilleurscore01[i]);
			}
			glRasterPos2f(585*rapportx2+largeur2/2-largeur3/2,550*rapporty2);
			for(i=0;i<strlen(meilleurscore01);i++)
			{
				glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24,meilleurscore01[i]);
			}

			largeur3=0;
			for(i=0;i<strlen(meilleurscore02);i++)
			{
				largeur3=largeur3+glutBitmapWidth(GLUT_BITMAP_TIMES_ROMAN_24,meilleurscore02[i]);
			}
			glRasterPos2f(585*rapportx2+largeur2/2-largeur3/2,525*rapporty2);
			for(i=0;i<strlen(meilleurscore02);i++)
			{
				glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24,meilleurscore02[i]);
			}

			largeur3=0;
			for(i=0;i<strlen(meilleurscore03);i++)
			{
				largeur3=largeur3+glutBitmapWidth(GLUT_BITMAP_TIMES_ROMAN_24,meilleurscore03[i]);
			}
			glRasterPos2f(585*rapportx2+largeur2/2-largeur3/2,500*rapporty2);
			for(i=0;i<strlen(meilleurscore03);i++)
			{
				glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24,meilleurscore03[i]);
			}

			glEnable(GL_TEXTURE_2D);
		}

		glDisable (GL_TEXTURE_2D);
		glEnable(GL_DEPTH_TEST);

		/* Repasse en projection 3d */
		glMatrixMode(GL_PROJECTION);
		glPopMatrix();
		glMatrixMode(GL_MODELVIEW);
	}

#ifdef SWIN32
	timerwindows();
#endif

#ifdef SLINUX
	timerlinux();
#endif
}

void Display2()
{
	/* Vide les tampons couleurs et profondeurs avec la couleur dsire. */
	glClearColor(0.10,0.10,0.10,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glColor3d(1,1,1);

	/* Affichage de la texture de fond des menus */
	glEnable (GL_TEXTURE_2D);
	glBindTexture (GL_TEXTURE_2D, 25);
	glBegin(GL_QUADS);

	glTexCoord2i(0,0);
	glVertex2i(0,0);
	glTexCoord2i(1,0);
	glVertex2i(width,0);
	glTexCoord2i(1,1);
	glVertex2i(width,height);
	glTexCoord2i(0,1);
	glVertex2i(0,height);

	glEnd();

	if(sourisx>=13 && sourisx<=123 && sourisy<=height-177 && sourisy>=height-199)
	{
		reso=1;
		forme=1;
	}
	else if(sourisx>=13 && sourisx<=123 && sourisy<=height-209 && sourisy>=height-230)
	{
		reso=2;
		forme=1;
	}
	else if(sourisx>=386 && sourisx<=494 && sourisy<=height-177 && sourisy>=height-199)
	{
		reso=3;
		forme=1;
	}
	else if(sourisx>=386 && sourisx<=494 && sourisy<=height-209 && sourisy>=height-230)
	{
		reso=4;
		forme=1;
	}
	else
	{
		reso=0;
		forme=0;
	}

	if(forme==0)
	{
		glBindTexture (GL_TEXTURE_2D, 1);
		son=1;
	}
	else if(forme==1)
	{
		if(son==1)
		{
			if(pasbruitage==0)Mix_PlayChannel(-1, son_3, 0);
			son=0;
		}
		glBindTexture (GL_TEXTURE_2D, 3);
	}

	/* Dfinission de la zone d'affichage de la texture en fonction de la position de la souris */
	glBegin(GL_QUADS);

	glTexCoord2f(0.0, 1.0);
	glVertex2i(sourisx,sourisy);

	glTexCoord2f(1.0, 1.0);
	glVertex2i(sourisx+60*rapportx,sourisy);

	glTexCoord2f(1.0, 0.0);
	glVertex2i(sourisx+60*rapportx, sourisy-60*rapportx);

	glTexCoord2f(0.0, 0.0);
	glVertex2i(sourisx, sourisy-60*rapportx);

	glEnd();

	glDisable (GL_TEXTURE_2D);

	glutSwapBuffers();
}


void Displayreseau()
{
	char buffer[10];
	char chaine[75];
	int positiond;

	/* Vide les tampons couleurs et profondeurs avec la couleur dsire. */
	glClearColor(0.10,0.10,0.10,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glColor3d(1,1,1);

	/* Affichage de la texture de fond des menus */
	glEnable (GL_TEXTURE_2D);
	glBindTexture (GL_TEXTURE_2D, 30);
	glBegin(GL_QUADS);

	glTexCoord2i(0,0);
	glVertex2i(0,0);
	glTexCoord2i(1,0);
	glVertex2i(width,0);
	glTexCoord2i(1,1);
	glVertex2i(width,height);
	glTexCoord2i(0,1);
	glVertex2i(0,height);

	glEnd();

	glColor3d(0,0,0);

	afficher_texte((unsigned char *)"[CHATBOX]", 17*rapportx2, 62*rapportx2, height-12*rapportx2, 4, 0, 0);
	afficher_texte((unsigned char *)"[PARTIES EN COURS]", 17*rapportx2, 62*rapportx2, height-347*rapportx2, 4, 0, 0);
	afficher_texte((unsigned char *)"[UTILISATEURS]", 17*rapportx2, 497*rapportx2, height-12*rapportx2, 4, 0, 0);
	afficher_texte((unsigned char *)"[CREER UNE NOUVELLE PARTIE]", 17*rapportx2, 497*rapportx2, height-347*rapportx2, 4, 0, 0);

	glColor3d(0,0,1);
	afficher_texte((unsigned char *)"En partie", 16*rapportx2, 732*rapportx2, height-91*rapportx2, 4, 1, 0);
	glColor3d(0.02353,0,0.5);
	afficher_texte((unsigned char *)"En attente", 16*rapportx2, 732*rapportx2, height-123*rapportx2, 4, 1, 0);
	glColor3d(0,0,0);

	afficher_texte((unsigned char *)"Nom de la nouvelle partie", 17*rapportx2, 616*rapportx2, height-390*rapportx2, 4, 1, 0);
	afficher_texte((unsigned char *)"Activer l'acceleration de la balle", 17*rapportx2, 616*rapportx2, height-450*rapportx2, 4, 1, 0);

	strcpy((char*)nomserveur, "[PonGL] Serveur officiel 1.1");
	afficher_texte(nomserveur, 25*rapportx2, 400*rapportx2, height-315*rapportx2, 3, 1, 0);

	if(inputline==1)
	{
		afficher_texte(chatboxtext, 19*rapportx2, 45*rapportx2, height-281*rapportx2, 4, 0, 1);
		afficher_texte(newgametext, 19*rapportx2, 616*rapportx2, height-416*rapportx2, 4, 1, 0);
	}
	else if(inputline==0)
	{
		afficher_texte(chatboxtext, 19*rapportx2, 45*rapportx2, height-281*rapportx2, 4, 0, 0);
		afficher_texte(newgametext, 19*rapportx2, 616*rapportx2, height-416*rapportx2, 4, 1, 1);
	}
	
	for(i=0;i<12;i++)
	{
		if(chatbox[i].pseudo[0]!='\0')
		{
			strcpy((char*)temppseudo, "[");
			strcat((char*)temppseudo, (char*)chatbox[i].pseudo);
			strcat((char*)temppseudo, "]");

			glColor3d(0,0,1);
			afficher_texte(temppseudo, 18*rapportx2, 39*rapportx2, height-(37+i*20)*rapportx2, 4, 0, 0);
			glColor3d(0,0,0);
			afficher_texte(chatbox[i].message, 18*rapportx2, 39*rapportx2+3*rapportx2+largeur_texte(temppseudo, 18*rapportx2, 4), height-(37+i*20)*rapportx2, 3, 0, 0);
		}
	}
	
	j=0;
	for(i=0;i<10;i++)
	{
		if(utilisateurs[i].etat!=0)
		{
			if(utilisateurs[i].etat == 1) glColor3d(0.02353,0,0.5);
			else glColor3d(0,0,1);
			afficher_texte(utilisateurs[i].pseudo, 20*rapportx2, 566*rapportx2, height-(36+j*27.6)*rapportx2, 4, 1, 0);
			j++;
		}
	}

	glColor3d(0,0,0);

	j=0;
	for(i=0;i<5;i++)
	{
				if(i==infos) glColor3d(0,0,1);
				else glColor3d(0,0,0);
				afficher_texte(parties[i].nom, 16*rapportx2, 37*rapportx2, height-(369+j*21)*rapportx2, 4, 0, 0);
				j++;
	}

	j=0;
	glColor3d(0,0,0);
	strcpy(chaine, "Informations sur la partie : ");
	strcat(chaine, "\"");
	strcat(chaine, (char*)parties[infos].nom);
	strcat(chaine, "\"");

	positiond=(233-largeur_texte((unsigned char *)chaine, 16, 4)/2)*rapportx2;

	afficher_texte((unsigned char *)"Informations sur la partie : ", 16*rapportx2, positiond, height-476*rapportx2, 4, 0, 0);
	glColor3d(0.02353,0,0.5);

	strcpy(chaine, "\"");
	strcat(chaine, (char*)parties[infos].nom);
	strcat(chaine, "\"");
	afficher_texte((unsigned char *)chaine, 16*rapportx2, positiond + largeur_texte((unsigned char *)"Informations sur la partie : ", 16*rapportx2, 4) + 4, height-476*rapportx2, 4, 0, 0);
	glColor3d(0,0,0);
	afficher_texte((unsigned char *)"Pseudo", 16*rapportx2, 43*rapportx2, height-514*rapportx2, 3, 0, 0);
	afficher_texte((unsigned char *)"Points", 16*rapportx2, 43*rapportx2, height-532*rapportx2, 3, 0, 0);
	afficher_texte((unsigned char *)"Inertie", 16*rapportx2, 43*rapportx2, height-549*rapportx2, 3, 0, 0);

	afficher_texte((unsigned char *)"Joueur 1", 16*rapportx2, 154*rapportx2, height-497*rapportx2, 3, 1, 0);
	glColor3d(0.02353,0,0.5);
	afficher_texte(parties[infos].joueur1, 16*rapportx2, 154*rapportx2, height-514*rapportx2, 3, 1, 0);
	sprintf(buffer, "%d", parties[infos].point1);
	afficher_texte((unsigned char *)buffer, 16*rapportx2, 154*rapportx2, height-532*rapportx2, 3, 1, 0);

	if(parties[infos].inertie1 == 1) afficher_texte((unsigned char *)"active", 16*rapportx2, 154*rapportx2, height-549*rapportx2, 3, 1, 0);
	else afficher_texte((unsigned char *)"non-active", 16*rapportx2, 154*rapportx2, height-549*rapportx2, 3, 1, 0);

	glColor3d(0,0,0);
	afficher_texte((unsigned char *)"Joueur 2", 16*rapportx2, 231*rapportx2, height-497*rapportx2, 3, 1, 0);
	glColor3d(0.02353,0,0.5);
	afficher_texte(parties[infos].joueur2, 16*rapportx2, 231*rapportx2, height-514*rapportx2, 3, 1, 0);

	sprintf(buffer, "%d", parties[infos].point2);
	afficher_texte((unsigned char *)buffer, 16*rapportx2, 231*rapportx2, height-532*rapportx2, 3, 1, 0);

	if(parties[infos].inertie2 == 1) afficher_texte((unsigned char *)"active", 16*rapportx2, 231*rapportx2, height-549*rapportx2, 3, 1, 0);
	else afficher_texte((unsigned char *)"non-active", 16*rapportx2, 231*rapportx2, height-549*rapportx2, 3, 1, 0);

	if(parties[infos].acceleration == 1) afficher_texte((unsigned char *)"acc. balle active", 16*rapportx2, 194*rapportx2, height-567*rapportx2, 3, 1, 0);
	else afficher_texte((unsigned char *)"acc. balle non-active", 16*rapportx2, 194*rapportx2, height-567*rapportx2, 3, 1, 0);

	glColor3d(1,1,1);

	if(sourisx>=398*rapportx2 && sourisx<=426*rapportx2 && sourisy<=height-278*rapportx2 && sourisy>=height-301*rapportx2)
	{
		choix=26;
		forme=1;
	}
	else if(parties[0].nom[0]!='\0' && sourisx>=33*rapportx2 && sourisx<=432*rapportx2 && sourisy<=height-367*rapportx2 && sourisy>=height-386*rapportx2)
	{
		choix=27;
		forme=1;
	}
	else if(parties[1].nom[0]!='\0' && sourisx>=33*rapportx2 && sourisx<=432*rapportx2 && sourisy<=height-388*rapportx2 && sourisy>=height-407*rapportx2)
	{
		choix=28;
		forme=1;
	}
	else if(parties[2].nom[0]!='\0' && sourisx>=33*rapportx2 && sourisx<=432*rapportx2 && sourisy<=height-409*rapportx2 && sourisy>=height-428*rapportx2)
	{
		choix=29;
		forme=1;
	}
	else if(parties[3].nom[0]!='\0' && sourisx>=33*rapportx2 && sourisx<=432*rapportx2 && sourisy<=height-430*rapportx2 && sourisy>=height-449*rapportx2)
	{
		choix=30;
		forme=1;
	}
	else if(parties[4].nom[0]!='\0' && sourisx>=33*rapportx2 && sourisx<=432*rapportx2 && sourisy<=height-451*rapportx2 && sourisy>=height-470*rapportx2)
	{
		choix=31;
		forme=1;
	}
	else if(sourisx>=40*rapportx2 && sourisx<=392*rapportx2 && sourisy<=height-278*rapportx2 && sourisy>=height-301*rapportx2)
	{
		choix=32;
		forme=1;
	}
	else if(sourisx>=487*rapportx2 && sourisx<=747*rapportx2 && sourisy<=height-413*rapportx2 && sourisy>=height-435*rapportx2)
	{
		choix=33;
		forme=1;
	}
	else if(sourisx>=605*rapportx2 && sourisx<=629*rapportx2 && sourisy<=height-474*rapportx2 && sourisy>=height-498*rapportx2)
	{
		choix=34;
		forme=1;
	}
	else
	{
		choix=0;
		forme=0;
	}

	if(forme==0)
	{
		glBindTexture (GL_TEXTURE_2D, 1);
		son=1;
	}
	else if(forme==1)
	{
		if(son==1)
		{
			if(pasbruitage==0)Mix_PlayChannel(-1, son_3, 0);
			son=0;
		}
		glBindTexture (GL_TEXTURE_2D, 3);
	}


	glDisable (GL_TEXTURE_2D);

	glColor3d(0,0,0);
	if(accballereseau==1)
	{
		glBegin(GL_QUADS);
			glVertex2i(605*rapportx2,height-474*rapportx2);
			glVertex2i(605*rapportx2,height-498*rapportx2);
			glVertex2i(629*rapportx2,height-498*rapportx2);
			glVertex2i(629*rapportx2,height-474*rapportx2);
		glEnd();
	}

	glEnable (GL_TEXTURE_2D);

	glColor3d(1,1,1);
	/* Dfinission de la zone d'affichage de la texture en fonction de la position de la souris */
	glBegin(GL_QUADS);

	glTexCoord2f(0.0, 1.0);
	glVertex2i(sourisx,sourisy);

	glTexCoord2f(1.0, 1.0);
	glVertex2i(sourisx+60*rapportx,sourisy);

	glTexCoord2f(1.0, 0.0);
	glVertex2i(sourisx+60*rapportx, sourisy-60*rapportx);

	glTexCoord2f(0.0, 0.0);
	glVertex2i(sourisx, sourisy-60*rapportx);

	glEnd();

	glDisable (GL_TEXTURE_2D);

#ifdef SWIN32
	timerwindows();
#endif

#ifdef SLINUX
	timerlinux();
#endif
}

/*******************************\FONCTION DU RENDU DE L'ECRAN*********************************/
