#ifndef DISPLAY_H
#define DISPLAY_H

/*********************************************************************************************/
/******                        DECLARATIONS ET INITIALISATIONS                          ******/
/******                        -------------------------------                          ******/
/******    Display : fonction d'affichage                                               ******/
/******                                                                                 ******/
/******    Les variables externes sont expliques dans le fichier main.c                ******/
/******                                                                                 ******/
/******    largeur2, largeur3 : contient des donnes utiles pour centrer du texte       ******/
/******    i : variable d'incrmentation                                                ******/
/******                                                                                 ******/
/*********************************************************************************************/

#ifdef SWIN32
	#include <windows.h>
#endif
#ifdef SLINUX
	#include <time.h>
	#include <unistd.h>
#endif
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glut.h>
#include <SDL/SDL.h>
#include <SDL/SDL_thread.h>
#include <SDL/SDL_mixer.h>
#include "mouvpal.h"
#include "ia.h"
#include "divers.h"
#include "collisio.h"
#include "decor.h"
#include "typedef.h"

void timerwindows();
void timerlinux();
void Display();
void Display2();
void Displayreseau();

extern int mode, options, choix, forme, son, choixia, refresh, swapfini, mouv, ajoutpoint;
extern int vsync, sourisactive, fer, accballe, inertie, reso_1024, pasmusique, pasbruitage, barredespace;
extern int width, height;
extern float rapportx, rapporty, rapportx2, rapporty2;
extern int sourisx, sourisy;
extern int options, menuquit, credits, menudifficulte, reseau, menuip, accballereseau;
extern char victoire[10];
extern char * victoire01;
extern char * victoire02;
extern char * victoire03;
extern char * victoire04;
extern char * victoire05;
extern Mix_Chunk * son_3;
extern Mix_Chunk * son_beep1;
extern float camx, camy, camz;
extern float vertx, verty, vertz;
extern double ballex, balley, ballez;
extern double ballevx, ballevy, ballevz;
extern float palettegy, palettedy;
extern double palettegvy, palettedvy;
extern int j;
extern float rotballe;
extern char meilleursscores[17];
extern char * meilleurscore01;
extern char * meilleurscore02;
extern char * meilleurscore03;
extern int points;
extern int fps;
#ifdef SWIN32
	extern LONGLONG lastTime;
	extern LONGLONG currentTime;
	extern LONGLONG lastTime2;
	extern LONGLONG currentTime2;
	extern LONGLONG frequence;
#endif
#ifdef SLINUX
	extern double lastTime;
	extern double currentTime;
	extern double lastTime2;
	extern double currentTime2;
	#define BILLION  1000000000L;
	struct timespec currenttimet;
#endif
extern char score[13];
extern int reso, infos, inputline;
extern unsigned char nomserveur[31];
extern struct messagechatbox chatbox[12];
extern struct liste_utilisateurs utilisateurs[10];
extern struct liste_parties parties[5];
extern int * animperso;

float largeur2;
float largeur3;
int i,j;
unsigned char temppseudo[15];
int selectperso; // Le personnage slectionn parmis ceux de "animperso" ( partir de 1)
int oldselectperso; // L'ancien personnage slectionn parmis ceux de "animperso" ( partir de 1)
float fade; // Fondu de l'affichage du perso : "0 = pas affich" ==> "1 = affich"

/******************************\DECLARATIONS ET INITIALISATIONS*******************************/


#endif
