#include "divers.h"

/*********************************************************************************************/
/******                        FONCTION D'ATTENTE D'UN EVENEMENT                        ******/
/******                        ---------------------------------                        ******/
/******    Idle est une fonction qui s'excute quand aucun autre venement n'est prvu  ******/
/******    et pour viter de ne rien faire, la fonction va rafficher l'cran           ******/
/******                                                                                 ******/
/******    glutWarpPointer : force la souris  se mettre sur une position prcise de    ******/
/******                      l'cran                                                    ******/
/******    glutPostRedisplay : force le raffichage de la scne quand il n'y a rien     ******/
/******                        d'autre  faire                                          ******/
/******                                                                                 ******/
/******    Les conditions utilises ici servent  faire bouger la camra d'une position ******/
/******     une autre en incrmentant ou dcrmentant les diffrentes valeurs de la    ******/
/******    camra.                                                                      ******/
/******                                                                                 ******/
/*********************************************************************************************/

void Idle()
{
	//	glutWarpPointer(WIDTH/2,HEIGHT/2);
	if(arret==0)
	{
		/* Les mouvements qui suivent servent  diriger la camra lors d'une partie */
		/* (Perdre la main, rcuprer la main, etc) */

		/* Mouvement de la gauche vers le centre */
		if(mouv==1)
		{
			if(camz<500)camz=camz+(float)1/refresh*85;
			else camz=500;
			if(camx<0)camx=camx+(float)2.75/refresh*85;
			else camx=0;
			if(verty<1)verty=verty+(float)0.005/refresh*85;
			else verty=1;
			if(vertx>0)vertx=vertx-(float)0.005/refresh*85;
			else vertx=0;
			if(camz==500 && camx==0 && verty==1 && vertx==0)
			{
				arret=1;
				j=0;
			}
		}

		/* Mouvement du centre vers la gauche */
		else if(mouv==2)
		{
			if(camz>300)camz=camz-(float)1/refresh*85;
			else camz=300;
			if(camx>-550)camx=camx-(float)2.75/refresh*85;
			else camx=-550;
			if(vertx<1)vertx=vertx+(float)0.005/refresh*85;
			else vertx=1;
			if(verty>0)verty=verty-(float)0.005/refresh*85;
			else verty=0;
			if(camz==300 && camx==-550 && vertx==1 && verty==0)
			{
				arret=1;
				j=0;
			}
		}

		/* Mouvement du centre vers la droite */
		else if(mouv==3)
		{
			if(camz>300)camz=camz-(float)1/refresh*85;
			else camz=300;
			if(camx<550)camx=camx+(float)2.75/refresh*85;
			else camx=550;
			if(vertx>-1)vertx=vertx-(float)0.005/refresh*85;
			else vertx=-1;
			if(verty>0)verty=verty-(float)0.005/refresh*85;
			else verty=0;
			if(camz==300 && camx==550 && vertx==-1 && verty==0)
			{
				arret=1;
				j=0;
			}
		}

		/* Mouvement de la droite vers le centre */
		else if(mouv==4)
		{
			if(camz<500)camz=camz+(float)1/refresh*85;
			else camz=500;
			if(camx>0)camx=camx-(float)2.75/refresh*85;
			else camx=0;
			if(verty<1)verty=verty+(float)0.005/refresh*85;
			else verty=1;
			if(vertx<0)vertx=vertx+(float)0.005/refresh*85;
			else vertx=0;
			if(camz==500 && camx==0 && vertx==0 && verty==1)
			{
				arret=1;
				j=0;
			}
		}

		/* Camra au centre pour le dbut d'une partie 2 joueurs */
		else if(mouv==0)
		{
			camz=500;
			arret=1;
		}

		/* Camra au centre pour le dbut d'une partie 1 joueur */
		else if(mouv==-1)
		{
			camz=300;
			arret=1;
		}
		up=0;down=0;up2=0;down2=0;
	}
	
	if(fade < 0.8)
		fade = fade + 0.02;
	else fade = 0.8;
	
	glutPostRedisplay();
}

/******************************\FONCTION D'ATTENTE D'UN EVENEMENT*****************************/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
/*********************************************************************************************/
/******                      FONCTION DE REACTUALISATION DE L'ECRAN                     ******/
/******                      --------------------------------------                     ******/
/******    Cette fonction est appele par un callback chaques fois que la fentre est   ******/
/******    ractualise ou bien redimensionne.  Elle permet de choisir le mode de      ******/
/******    projection en fonction de si on est dans le menu ou de si on est dans le jeu.******/
/******    Elle permet galement de savoir dans quelle rsolution on se trouve et d'agir******/
/******    en fonction.                                                                 ******/
/******                                                                                 ******/
/*********************************************************************************************/

void Reshape(int w, int h)
{
	if(reso==3)
	{
		width=640;
		height=480;
		glutReshapeWindow(640, 480);
	}
	else if(reso==4)
	{
		width=800;
		height=600;
		glutReshapeWindow(800, 600);
	}
	else
	{
		width=w;
		height=h;
	}
	rapportx=(float)width/1024;
	rapporty=(float)height/768;
	rapportx2=(float)width/800;
	rapporty2=(float)height/600;
	glViewport(0,0,width,height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	if(mode==1)
	{
		glDisable(GL_DEPTH_TEST);
		gluOrtho2D(0, width, 0, height);
	}
	else
	{
		glEnable(GL_DEPTH_TEST);
		gluPerspective(60.0,(float) width/height,1,10000000);
	}
}

void Reshape2(int w, int h)
{
	if(w!=512 || h!=256) glutReshapeWindow(512, 256);
	width=512;
	height=256;
	rapportx=(float)width/1024;
	rapporty=(float)height/768;
	rapportx2=(float)width/800;
	rapporty2=(float)height/600;
	glViewport(0,0,width,height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glDisable(GL_DEPTH_TEST);
	gluOrtho2D(0, width, 0, height);
}

/***************************\FONCTION DE REACTUALISATION DE L'ECRAN***************************/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
/*********************************************************************************************/
/******                        CALCUL SIMPLE DE VALEUR ABSOLUE                          ******/
/******                        -------------------------------                          ******/
/******    Fonction trs simple du calcul simplifi de valeur absolue.                  ******/
/******                                                                                 ******/
/*********************************************************************************************/

int vabs(int valeur)
{
	if(valeur>=0) return valeur;
	else return -valeur;
}

/******************************\CALCUL SIMPLE DE VALEUR ABSOLUE*******************************/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
/*********************************************************************************************/
/******                             LANCEMENT DE LA BALLE                               ******/
/******                             ---------------------                               ******/
/******    Fonction qui s'excute lors du lancement de la balle qu'il soit automatique  ******/
/******    ou bien dpendant de la barre d'espace.                                      ******/
/******    Le lancement s'effectue en fonction d'un random et d'autres paramtres       ******/
/******    qui dpendent, par exemple, du niveau de difficult.                         ******/
/******                                                                                 ******/
/*********************************************************************************************/

void lancerballe()
{
	if(points==0 || points==6)
	{
		if(mode==3) choix=choixia+14;
		if(mode==4) choix=3;
		mode=1;
		sourisclic(0, 1, 0, 0);
	}
	else if(ballevx==0)
	{
		sprintf(score01, "%d", 0);
		if((choixia==1 || choixia==2) || mode==2 || mode==4)
		{
			randnumber=rand()%2;
			randnumber2=rand()%2;
			if(randnumber==0)ballevx=(float)4/refresh*85;
			else if(randnumber==1)ballevx=-(float)4/refresh*85;
			if(randnumber2==0)ballevy=(float)4/refresh*85;
			else if(randnumber2==1)ballevy=-(float)4/refresh*85;
		}
		else if(choixia==3)
		{
			randnumber=rand()%2;
			randnumber2=rand()%2;
			randnumber3=rand()%2;
			randnumber4=rand()%2;
			if(randnumber==0)ballevx=(float)(4+randnumber3)/refresh*85;
			else if(randnumber==1)ballevx=-(float)(4+randnumber3)/refresh*85;
			if(randnumber2==0)ballevy=(float)(4+randnumber4)/refresh*85;
			else if(randnumber2==1)ballevy=-(float)(4+randnumber4)/refresh*85;
		}
		else if(choixia==4 || choixia==5)
		{
			randnumber=rand()%2;
			randnumber2=rand()%2;
			randnumber3=rand()%2;
			randnumber4=rand()%4;
			if(randnumber==0)ballevx=(float)(4+randnumber3)/refresh*85;
			else if(randnumber==1)ballevx=-(float)(4+randnumber3)/refresh*85;
			if(randnumber2==0)ballevy=(float)(4+randnumber4)/refresh*85;
			else if(randnumber2==1)ballevy=-(float)(4+randnumber4)/refresh*85;
		}
	}
}

/***********************************\LANCEMENT DE LA BALLE************************************/


//la fonction ascii retourne le nombre de pixels que prend le caractre
void ascii(int num_police, unsigned char caractere, int x, int y, int taille)
{
	int temp, positionx, positiony;
	float positionfx, positionfy;

	temp=(int)caractere - 32;
	if(num_police==2 || num_police==4) temp=temp+128;

	if(temp<256 && temp>=0)
	{
		positionx=temp%16;
		positiony=temp/16;

		positionfx=(float)positionx/16;
		positionfy=(float)positiony/16;

		if(num_police==1 || num_police==2) glBindTexture (GL_TEXTURE_2D, 27);
		else if(num_police==3 || num_police==4) glBindTexture (GL_TEXTURE_2D, 29);

		glBegin(GL_QUADS);
			glTexCoord2f(positionfx, positionfy);
			glVertex2i(x, y);

			glTexCoord2f(positionfx+0.0625, positionfy);
			glVertex2i(x + taille, y);

			glTexCoord2f(positionfx+0.0625, positionfy+0.0625);
			glVertex2i(x + taille, y - taille);

			glTexCoord2f(positionfx, positionfy+0.0625);
			glVertex2i(x, y - taille);
		glEnd();
	}
}

int largeur_texte(unsigned char *texte, int taille, int num_police)
{
	int i;
	int tailletexte=0;

	for(i=0;texte[i]!='\0';i++)
	{
		tailletexte=tailletexte+largeur_caractere(texte[i], taille, num_police);
	}
	return tailletexte;
}

int largeur_caractere(unsigned char a, int taille, int num_police)
{
	if(num_police==1 || num_police==2) return (inichars[(int)a-32]*taille/32);
	else if(num_police==3) return (inichars2[(int)a-32]*taille/32);
	else if(num_police==4) return (inichars2[128+(int)a-32]*taille/32);
	else return 0;
}

void afficher_texte(unsigned char *texte, int taille, int x, int y, int num_police, int center, int anim)
{
	int decal=0, decaltotal=0;
	int i=0;

	if(center==1)
	{
		if(anim==0) x=x-largeur_texte(texte, taille, num_police)/2;
		else if(anim==1) x=x-(largeur_texte(texte, taille, num_police)+largeur_caractere('_', taille, num_police))/2;
	}

	for(i=0;texte[i]!='\0';i++)
	{
		decal=largeur_caractere(texte[i], taille, num_police);	//Calcul de la largeur du caractre actuel
		decal=(taille-decal)/2;						//Calcul de la zone de dpassement de l'actuel.
		ascii(num_police, texte[i], x+decaltotal-decal, y, taille);	//criture de l'actuel
		decaltotal=decaltotal+largeur_caractere(texte[i], taille, num_police); 	//dcallage total
	}

	if(anim==1 && fps>43)
	{
		decal=largeur_caractere('_', taille, num_police);	//Calcul de la largeur du caractre actuel
		decal=(taille-decal)/2;						//Calcul de la zone de dpassement de l'actuel.
		ascii(num_police, '_', x+decaltotal-decal, y, taille);	//criture de l'actuel
	}
}

void chatbox_new(unsigned char *phrase, unsigned char *pseudo)
{
	struct messagechatbox new;

	new.message=(unsigned char*)malloc((strlen((char*)phrase)+1)*sizeof(unsigned char));
	strcpy((char *)new.message, (char *)phrase);
	strcpy((char *)new.pseudo, (char *)pseudo);

	free(chatbox[0].message);
	free(chatbox[0].pseudo);

	for(i=0;i<=10;i++)

	{
		chatbox[i]=chatbox[i+1];
	}


	chatbox[11]=new;
}

void triutilisateurs()
{
	int i, j;
	struct liste_utilisateurs temp;

	for(i=1;i<=9;i++)
	{
		for(j=0;j<=9-i;j++)
		{
			if(strcmp((char *)minuscules_pseudo(utilisateurs[j].pseudo), (char *)minuscules_pseudo(utilisateurs[j+1].pseudo)) > 0)
			{
				temp=utilisateurs[j];
				utilisateurs[j]=utilisateurs[j+1];
				utilisateurs[j+1]=temp;
			}
		}
	}
}

void triparties()
{
	int i, j;
	struct liste_parties temp;

	for(i=1;i<=4;i++)
	{
		for(j=0;j<=4-i;j++)
		{
			if(parties[j].nom[0] == '\0' || (parties[j+1].nom[0] != '\0' && strcmp((char *)minuscules_pseudo(parties[j].nom), (char *)minuscules_pseudo(parties[j+1].nom)) > 0))
			{
				temp=parties[j];
				parties[j]=parties[j+1];
				parties[j+1]=temp;
			}
		}
	}
}

unsigned char * minuscules_pseudo(unsigned char * texte)
{
	unsigned char * temp;

	temp=(unsigned char*)malloc((strlen((char *)texte)+1)*sizeof(unsigned char));

	for(i=0;i<=strlen((char *)texte);i++)
	{
		if(texte[i]>='A' && texte[i]<='Z') temp[i]=texte[i]+32;
		else temp[i]=texte[i];
	}
	return temp;
}

void print_screen()
{
	FILE * file;
	int i;
	unsigned char * data;

	//Cherche le nom a suavegarder soit PICTURE1 ou PICTURE2 [ de 1 jusqu'a 2000 ]
	char filename[32];

	for(i=0; i<2000; i++)
	{
		sprintf(filename, "screenshots/PonGL%03d.tga", i);
		//essey d'ouvrir ce fichier si c impossible alors en le crer pour sauvegarder l'image
		file=fopen(filename, "rb");

		if(!file)
		{
			break;
		}
		//sinon si le fichier existe alors en continue a chercher le suivant
		fclose(file);
	}

	/*Structure de des fichiers TGA*/
	GLubyte TGAheader[12]={0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0}; // entete TGA non compresser
	GLubyte infoHeader[6];

	data=(unsigned char *)malloc(4*width*height*sizeof(unsigned char));

	//Lire les donn depuis l'cran
	glReadPixels(0, 0, width, height, GL_RGBA, GL_UNSIGNED_BYTE, data);

	//les donn doivent etre au format RGB [ RED , GREEN , BLUE]
	//echange le Blue et le Red
	for(i=0; i<(int)width*height*4; i+=4)
	{
		//repete le XOR pour echang les bytes 0 et 2
		data[i] ^= data[i+2] ^= data[i] ^= data[i+2];
	}

	//ouvrir le fichier
	file = fopen(filename, "wb");

	//Enregistre l'entete
	fwrite(TGAheader, 1, sizeof(TGAheader), file);

	//Enregiste les entetes
	infoHeader[0]=(width& 0x00FF);
	infoHeader[1]=(width & 0xFF00) >> 8;
	infoHeader[2]=(height& 0x00FF);
	infoHeader[3]=(height & 0xFF00) >> 8;
	infoHeader[4]=32;
	infoHeader[5]=0;

	//Enregistre les info sur le header
	fwrite(infoHeader, 1, sizeof(infoHeader), file);

	//Enregistre l'image
	fwrite(data, 1, width*height*4, file);

	fclose(file);

}


