#include "ia.h"

/*********************************************************************************************/
/******                     FONCTIONS D'INTELLIGENCES ARTIFICIELLES                     ******/
/******                     ---------------------------------------                     ******/
/******    Ici se trouvent 5 fonctions d'intelligences artificielles distinctes.  De la ******/
/******    plus nulle  la plus forte.                                                  ******/
/******    Elles sont bases sur des randoms (pour les plus nulles) jusqu'aux calculs   ******/
/******    de position optimale de la palette lors du contact pour les plus fortes.     ******/
/******                                                                                 ******/
/*********************************************************************************************/

/* Nulle */
void ia1()
{
	nbr_rand=rand();
	if(nbr_rand%8==1)
	{
		down2=0;
		up2=1;
	}
	else if(nbr_rand%8==0)
	{
		down2=1;
		up2=0;
	}
	else if(nbr_rand%8==2)
	{
		down2=0;
		up2=0;
	}
	else if(ballex+ballevx>-120 && balley+ballevy>=palettedy+palettedvy+30 && palettedy+50<=200)
	{
		up2=1;
		down2=0;
	}
	else if(ballex+ballevx>-120 && balley+ballevy<=palettedy+palettedvy-30 && palettedy-50>=-200)
	{
		up2=0;
		down2=1;
	}
	else
	{
		up2=0;
		down2=0;
	}
}

/* Moyenne */
void ia2()
{
	nbr_rand=rand();
	if(nbr_rand%15==1)
	{
		down2=0;
		up2=1;
	}
	else if(nbr_rand%15==0)
	{
		down2=1;
		up2=0;
	}
	else if(nbr_rand%15==2)
	{
		down2=0;
		up2=0;
	}
	else if(ballex+ballevx>-120 && balley+ballevy>=palettedy+palettedvy+30 && palettedy+50<=200)
	{
		up2=1;
		down2=0;
	}
	else if(ballex+ballevx>-120 && balley+ballevy<=palettedy+palettedvy-30 && palettedy-50>=-200)
	{
		up2=0;
		down2=1;
	}
	else
	{
		up2=0;
		down2=0;
	}
}

/* Moyenne-forte */
void ia3()
{
	nbr_rand=rand();
	if(nbr_rand%3==1 && ballex+ballevx<=-120 && palettedy+50<=200)
	{
		down2=0;
		up2=1;
	}
	else if(nbr_rand%3==0 && ballex+ballevx<=-120 && palettedy-50>=-200)
	{
		down2=1;
		up2=0;
	}
	else if(nbr_rand%3==2 && ballex+ballevx<=-120)
	{
		down2=0;
		up2=0;
	}
	else if(ballex+ballevx>-120 && balley+ballevy>=palettedy+palettedvy+30 && palettedy+50<=200)
	{
		up2=1;
		down2=0;
	}
	else if(ballex+ballevx>-120 && balley+ballevy<=palettedy+palettedvy-30 && palettedy-50>=-200)
	{
		up2=0;
		down2=1;
	}
	else
	{
		up2=0;
		down2=0;
	}
}

/* Forte */
void ia4()
{
	float positionfh;

	positionfh=balley+(((300-ballex)/ballevx)*ballevy);
	if(positionfh>200)
	{
		positionfh=220-(positionfh-200);
	}
	else if(positionfh<-220)
	{
		positionfh=-220-(positionfh+220);
	}

	if(ballevx>0 && palettedy+palettedvy>positionfh+10)
	{
		down2=1;
		up2=0;
	}
	else if(ballevx>0 && palettedy+palettedvy<positionfh-10)
	{
		up2=1;
		down2=0;
	}
	else if(ballevx<0 && palettedy+palettedvy<-10)
	{
		up2=1;
		down2=0;
	}
	else if(ballevx<0 && palettedy+palettedvy>10)
	{
		up2=0;
		down2=1;
	}
	else
	{
		down2=0;
		up2=0;
	}
}

/* Trs trs forte */
void ia5()
{
	float positionfh;

	positionfh=balley+(((300-ballex)/ballevx)*ballevy);
	while(positionfh>220 || positionfh<-220)
	{
		if(positionfh>200)
		{
			positionfh=220-(positionfh-200);
		}
		else if(positionfh<-220)
		{
			positionfh=-220-(positionfh+220);
		}
	}
	if(ballevx>0 && palettedy+palettedvy>positionfh+10)
	{
		down2=1;
		up2=0;
	}
	else if(ballevx>0 && palettedy+palettedvy<positionfh-10)
	{
		up2=1;
		down2=0;
	}
	else if(ballevx<0 && palettedy+palettedvy<-10)
	{
		up2=1;
		down2=0;
	}
	else if(ballevx<0 && palettedy+palettedvy>10)
	{
		up2=0;
		down2=1;
	}
	else
	{
		down2=0;
		up2=0;
	}
}

/**************************\FONCTIONS D'INTELLIGENCES ARTIFICIELLES***************************/
