#include "init.h"

/*********************************************************************************************/
/******                                 INITIALISATION                                  ******/
/******                                 --------------                                  ******/
/******    srand(time(0)) : charge un nombre au hasard en fonction de l'horloge interne ******/
/******    FSOUND_Init : initialisation de fmod                                         ******/
/******    FMUSIC_LoadSong : charge les musiques au format mid dans un pointeur         ******/
/******    FSOUND_Sample_Load : charge les musiques courtes (samples) pour bruitages    ******/
/******                         dans un pointeur                                        ******/
/******    glutSetCursor(GLUT_CURSOR_NONE) : fait disparaitre le curseur standart       ******/
/******    glutDisplayFunc : dfini la fonction d'affichage                             ******/
/******    glutReshapeFunc : dfini la fonction de redimensionnement                    ******/
/******    glutIdleFunc : dfini la fonction d'attente                                  ******/
/******    glutKeyboardFunc : dfini la fonction qui gre les touches normales          ******/
/******    glutKeyboardUpFunc : dfini la fonction qui gre le relachement des touches  ******/
/******                         normales                                                ******/
/******    glutSpecialFunc : dfini la fonction qui gre les touches spciales          ******/
/******    glutSpecialUpFunc : dfini la fonction qui gre le relachement des touches   ******/
/******    glutPassiveMotionFunc : dfini la fonction qui gre le dplacement de la     ******/
/******                            souris sans bouton appuy                            ******/
/******    glutMotionFunc : dfini la fonction qui gre le dplacement de la souris avec******/
/******                     des boutons appuys                                         ******/
/******    glutMouseFunc : dfini la fonction qui gre les clics de la souris           ******/
/******    loadTGA : charge une image tga  partir du rpertoire et la met en mmoire   ******/
/******    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) : dfini l'utilisation du  ******/
/******                                                        blending                 ******/
/******    glEnable(GL_BLEND) : active le blending (transparence)                       ******/
/******    glEnable(GL_POLYGON_OFFSET_FILL) : permet de mieux voir les contours         ******/
/******                                       (dcallage vers la camra)                ******/
/******                                                                                 ******/
/*********************************************************************************************/

void cleanExit(char *str,...)
{
	Mix_CloseAudio();
	SDL_Quit();
	exit(1);
}

void init()
{
	int i;
	
	srand(time(0));

	// initialize sdl mixer, open up the audio device
	if(Mix_OpenAudio(22050,MIX_DEFAULT_FORMAT,2,512)<0)
		cleanExit("Mix_OpenAudio");
	Mix_VolumeMusic(SDL_MIX_MAXVOLUME);
		
	son_menu = Mix_LoadMUS("data/menu.mid");
	son_jeu = Mix_LoadMUS("data/jeu.mid");
	son_3 = Mix_LoadWAV("data/3.wav");
	son_4 = Mix_LoadWAV("data/4.wav");
	son_5 = Mix_LoadWAV("data/5.wav");
	son_fly = Mix_LoadWAV("data/fly.wav");
	son_beep1 = Mix_LoadWAV("data/beep1.wav");

	glutSetCursor(GLUT_CURSOR_NONE);

	if(menureseau==0)
	{
		glutDisplayFunc(Display);
		glutKeyboardFunc(Touche);
	}
	else
	{
		glutKeyboardFunc(Touche4);
		glutDisplayFunc(Displayreseau);
		loadTGA("data/ascii2.tga",29);
		loadTGA("data/menureseau.tga",30);
	}
	
	glutReshapeFunc(Reshape);
	glutIdleFunc(Idle);
	glutKeyboardUpFunc(ToucheUp);
	glutSpecialFunc(ToucheSpec);
	glutSpecialUpFunc(ToucheSpecUp);

	glutPassiveMotionFunc(souris);
	glutMotionFunc(souris);
	glutMouseFunc(sourisclic);

	loadTGA("data/curseur.tga",1);
	if(langue == 0) //fr
	{
		loadTGA("data/menu.tga",2);
		loadTGA("data/joueur1gagne.tga",13);
		loadTGA("data/joueur2gagne.tga",14);
		loadTGA("data/options.tga",15);
		loadTGA("data/options2.tga",26);
		loadTGA("data/credits.tga",16);
		loadTGA("data/quitter.tga",17);
		loadTGA("data/difficulte.tga",18);
		loadTGA("data/waitreseau.tga",29);
	}
	else //en
	{
		loadTGA("data/menu-e.tga",2);
		loadTGA("data/joueur1gagne-e.tga",13);
		loadTGA("data/joueur2gagne-e.tga",14);
		loadTGA("data/options-e.tga",15);
		loadTGA("data/options2-e.tga",26);
		loadTGA("data/credits-e.tga",16);
		loadTGA("data/quitter-e.tga",17);
		loadTGA("data/difficulte-e.tga",18);
		loadTGA("data/waitreseau-e.tga",29);
	}
	
	loadTGA("data/curseurclic.tga",3);
	loadTGA("data/jauge06.tga",4);
	loadTGA("data/jauge16.tga",5);
	loadTGA("data/jauge26.tga",6);
	loadTGA("data/jauge36.tga",7);
	loadTGA("data/jauge46.tga",8);
	loadTGA("data/jauge56.tga",9);
	loadTGA("data/jauge66.tga",10);
	loadTGA("data/titre.tga",11);
	loadTGA("data/a.tga",12);
	loadTGA("data/smile01.tga",19);
	loadTGA("data/smile02.tga",20);
	loadTGA("data/smile03.tga",21);
	loadTGA("data/smile04.tga",22);
	loadTGA("data/smile05.tga",23);
	loadTGA("data/reseau.tga",24);
	loadTGA("data/ascii1.tga",27);
	loadTGA("data/serveur.tga",28);
	
	fade = 0;
	selectperso = oldselectperso = 1;
	animperso = (int*)malloc(7*sizeof(int));
	for(i=0;i<7;i++)
		animperso[i] = 30+i;
	loadTGA("data/1.tga",30);
	loadTGA("data/2.tga",31);
	loadTGA("data/3.tga",32);
	loadTGA("data/4.tga",33);
	loadTGA("data/5.tga",34);
	loadTGA("data/6.tga",35);
	loadTGA("data/7.tga",36);


	if(pasmusique==0 && mode==1) Mix_PlayMusic(son_menu, -1);
	else if(pasmusique==0 && mode!=1) Mix_PlayMusic(son_jeu, -1);

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);

	glEnable(GL_POLYGON_OFFSET_FILL);
}

void init2()
{
	// initialize sdl mixer, open up the audio device
	if(Mix_OpenAudio(22050,MIX_DEFAULT_FORMAT,2,512)<0)
		cleanExit("Mix_OpenAudio");
	Mix_VolumeMusic(SDL_MIX_MAXVOLUME);
		
	son_3 = Mix_LoadWAV("data/3.wav");

	glutSetCursor(GLUT_CURSOR_NONE);

	glutDisplayFunc(Display2);
	glutReshapeFunc(Reshape2);
	glutIdleFunc(Idle);

	glutPassiveMotionFunc(souris);
	glutMotionFunc(souris);
	glutMouseFunc(sourisclic2);

	loadTGA("data/curseur.tga",1);
	loadTGA("data/curseurclic.tga",3);
	if(langue == 0)
		loadTGA("data/intro.tga",25);
	else loadTGA("data/intro-e.tga",25);

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
}
