/*********************************************************************************************/
/*********************************************************************************************/
/**                                                                                         **/
/**         2004            PonGL             version 1.20            Michal Hoste         **/
/**                     Origin of Power                           CRAzy-flaSH@skynet.be     **/
/**                                                                                         **/
/**                  ----------------------------------------------                         **/
/**                  | Site officiel : http://pongl.opengl-fr.com |                         **/
/**                  ----------------------------------------------                         **/
/**                                                                                         **/
/**    Ce qui est fait : - Le dcor global du Pong (murs, palette, balle, fond).            **/
/**    ---------------   - Les mouvements de la balle grace  une vitesse et une position.  **/
/**                      - Les mouvements de la palette avec une lgre inertie.            **/
/**                      - Gestion des touches du clavier (fleches et ESC).                 **/
/**                      - La gestion des collisions avec les bords (balle et palette).     **/
/**                      - La gestion des collisions entre la balle et la palette.          **/
/**                      - Les sons d'impacts grce  une librairie externe.                **/
/**                      - Un menu de choix de mode de jeu (solo, 2 joueurs, 1vsCPU).       **/
/**                      - Une deuxime palette.                                            **/
/**                      - Une IA trs basique pour la deuxime palette.                    **/
/**                      - Une gestion des timers pour synchroniser selon le pc.            **/
/**                      - Une gestion de camra qui changera automatiquement en fonction du**/
/**                        joueur qui a l'avantage.                                         **/
/**                      - Un systme de points avec affichage au dessus de l'cran.        **/
/**                      - Mise en place des options avec choix de vsync, fil de fer et     **/
/**                        acclration de la balle.                                        **/
/**                      - mise en place des "fentres" options, crdits et quitter.        **/
/**                      - Un lancement de la balle bas sur des nombres random.            **/
/**                      - Enregistrer les paramtres des options dans un fichier.          **/
/**                      - Des IAs plus fortes et plus faibles pour la deuxime palette.    **/
/**                      - Un systme de scores pour le mode 1 joueur.                      **/
/**                      - Rajouter des fichiers midi pour une musique d'ambiance.          **/
/**                      - Remplacer WINMM par FMOD pour la lecture des sons ce qui rendra  **/
/**                        le code pratiquement entirement compatible linux.               **/
/**                      - Rajouter une option qui permet d'activer/dsactiver l'inertie des**/
/**                        palettes.                                                        **/
/**                      - Rajouter des options et finir celles du choix de refresh et de   **/
/**                        rsolution + options de sons (bruitage et musique).              **/
/**                      - Division de la source en plusieurs petits fichiers.              **/
/**                      - Le choix : mode fentr (+ rsolution) ou plein cran.           **/
/**                      - Basculer plein cran->fentr et vice versa par alt-enter.       **/
/**                      - Correction du petit bug qui ne permettait que d'appuyer sur enter**/
/**                        a la fin d'une partie.                                           **/
/**                                                                                         **/
/**    Ce qui reste  faire : - Un mode multijoueur en rseau via un serveur (PonGL 2.0).   **/
/**    --------------------   - Enlever les includes en trop dans le main.                  **/
/**                                                                                         **/
/*********************************************************************************************/
/*********************************************************************************************/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
/*********************************************************************************************/
/******                                  INCLUDES                                       ******/
/******                                  --------                                       ******/
/******    En-ttes des diverses librairies utilises :                                 ******/
/******    --------------------------------------------                                 ******/
/******                                                                                 ******/
/******    stdlib.h  : Pour grer les fonctions randoms                                 ******/
/******    strings.h : Pour les oprations sur les chaines (strlen)                     ******/
/******    windows.h : Pour les fonction en rapport avec l'horloge interne (timers)     ******/
/******    GL/gl.h   : Pour les fonctions opengl                                        ******/
/******    GL/glut.h : Pour les fonctions glut (entre clavier etc...)                  ******/
/******    tga.c     : Pour importer les images au format tga (LoadTGA)                 ******/
/******    fmod.h    : Pour pouvoir grer tous les sons dsirs (midi, mp3, wav, ...)   ******/
/******    time.h    : Pour pouvoir grer tous les sons dsirs (midi, mp3, wav, ...)   ******/
/******                                                                                 ******/
/******    En-tte de mes propres fichiers de code :                                    ******/
/******    -----------------------------------------                                    ******/
/******                                                                                 ******/
/******    ia.h      : Fonction de gestion de l'intelligence artificielle               ******/
/******    savefile.h: Fonctions de lecture et d'criture des prfrences dans un       ******/
/******                fichier pglconfig.cfg                                            ******/
/******    mouvpal.h : Fonctions de dplacement des palettes avec inertie et sans       ******/
/******    keyboard.h: Fonctions qui grent l'interactivit avec le clavier             ******/
/******    divers.h  : Fonctions diverses (reshape, idle, lancerballe, abs)             ******/
/******    mouse.h   : Fonctions qui grent l'interactivit avec la souris              ******/
/******    display.h : Fonction d'affichage appele par le callback de glut             ******/
/******    collisio.h: Fonction qui gre les collisions entre la balle et le dcor      ******/
/******    decor.h   : Fonction qui gre la mise en place du dcor (murs + palettes)    ******/
/******    init.h    : Fonctions d'initialisation                                       ******/
/******                                                                                 ******/
/*********************************************************************************************/

#include <stdlib.h>
#include <strings.h>
#ifdef SWIN32
	#include <windows.h>
#endif
#include <GL/gl.h>
#include <GL/glut.h>
//#include "tga.h"
//#include "fmod.h"
//#include "time.h"
//#include "ia.h"
#include "savefile.h"
//#include "mouvpal.h"
//#include "keyboard.h"
#include "divers.h"
//#include "mouse.h"
//#include "display.h"
//#include "collisio.h"
//#include "decor.h"
#include "init.h"
#include "typedef.h"

/****************************************\INCLUDES********************************************/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
/*********************************************************************************************/
/******                        DECLARATIONS ET INITIALISATIONS                          ******/
/******                        -------------------------------                          ******/
/******    width et height : ces variables reprsentent la rsolution de l'cran qui est******/
/******                      rcupre grce  la fonction Reshape lance au dmarrage  ******/
/******    rapportx, rapporty : permet de fixer un rapport en fonction de la rsolution ******/
/******                         actuelle et de la taille du rectangle qui reprsente    ******/
/******                         l'cran dans le jeu                                     ******/
/******    rapportx2, rapporty2 : rapports permettant de passer de 800*600  1024*768   ******/
/******    up(2)/down(2) : 0 si la touche "fleche haut/bas" est relche                ******/
/******                    1 si la touche "fleche haut/bas" est appuye                 ******/
/******    rotballe : variable permettant des rotations diverses                        ******/
/******    camx, camy, camz : les trois positions de la camra sur les diffrents axes  ******/
/******    vertx, verty, vertz : les trois verticales de la camra sur les diffrents   ******/
/******                          axes                                                   ******/
/******    ballex, balley, ballez : les trois positions de la balle sur les diffrents  ******/
/******                             axes                                                ******/
/******    ballevx, ballevy, ballevz : les trois vitesses de la balle sur les           ******/
/******                                diffrents axes                                  ******/
/******    palettegy : la position de la palette de gauche sur l'axe Y                  ******/
/******    palettegvy : la vitesse de la palette de gauche sur l'axe Y                  ******/
/******    palettedy : la position de la palette de droite sur l'axe Y                  ******/
/******    palettedvy : la vitesse de la palette de droite sur l'axe Y                  ******/
/******    i : simple variable permettant d'incrmenter les boucles                     ******/
/******    j : variable servant au compte  rebours.  si j>=0 alors le compte  rebours ******/
/******        est en cours et si j<0 alors le compte  rebours n'est pas en route.     ******/
/******        la valeur de j dcide de la position du feu et la valeur augmente toutes ******/
/******        les images si le compte  rebours est en route (j>=0)                    ******/
/******    mode : le mode correspond dans quelle partie du jeu o vous vous trouvez :   ******/
/******           1 = le menu principal                                                 ******/
/******           2 = le jeu 1 joueur contre mur                                        ******/
/******           3 = le jeu 1 joueur contre le pc                                      ******/
/******           4 = le jeu 2 joueurs sur le mme pc                                   ******/
/******    choix : prend un numro en fonction du menu qui a t cliqu                 ******/
/******    forme : si forme=1 alors le curseur est "actif"                              ******/
/******    son   : si le son=1 alors un son doit tre lanc                             ******/
/******    sourisx, sourisy : les coordonnes de la souris. utile pour les venements   ******/
/******    refresh : variable prenant la valeur du refresh de l'cran.  Elle a un impact******/
/******              important sur le gameplay                                          ******/
/******    mouv : position de la camra et dcideur du mouvement de celle ci            ******/
/******    victoire[10] : contient le texte : "Victoires"                               ******/
/******    victoire01[5],..,victoires05[5] : contient le nombre de victoires dans chacun******/
/******                                      des niveaux de difficult                  ******/
/******    score[13] : contient le texte : "Score actuel"                               ******/
/******    score01[10] : contient le score actuel dans la partie solo                   ******/
/******    meilleurscore01[10], ..., meilleurscore03[10] : contient les meilleurs scores******/
/******    arret : variable dfinissant si oui ou non les entres clavier sont dispos   ******/
/******    points : pour le score en deux joueurs.  Si points = 0 alors le joueur2 gagne******/
/******             et si points = 6 alors le joueur1 gagne                             ******/
/******    fps : variable permettant de compter les fps                                 ******/
/******    lastTime et currentTime : permettent de forcer la synchronisation verticale  ******/
/******                               la frquence dsire.                            ******/
/******    lastTime2 et currentTime2 : permettent d'afficher les fps toutes les secondes******/
/******    frequence : constante de l'horloge interne du processeur : nombre de "ticks" ******/
/******                par seconde                                                      ******/
/******    swapfini : variable permettant de dcider de l'affichage de l'cran lorsque  ******/
/******               la synchronisation verticale est active                          ******/
/******    options, menuquit, credits, menudifficulte, reseau : 1 si menu actif, 0 sinon******/
/******    vsync, fer, accballe, inertie, reso_1024, pasmusique, pasbruitage,           ******/
/******    barredespace : 1 si option active, 0 sinon                                   ******/
/******    choixia : de 1  5 en fonction du niveau de difficult choisi                ******/
/******    ajoutpoint : permet de voir si les points ont dj t mis  jour ou pas     ******/
/******    son_jeu, son_menu, son_3, son_4, son_5, son_fly, son_beep1 : pointeurs vers  ******/
/******    les sons utiles au jeu                                                       ******/
/******                                                                                 ******/
/*********************************************************************************************/

int width, height;
float rapportx, rapporty, rapportx2, rapporty2;
int up=0;
int down=0;
int up2=0;
int down2=0;
float rotballe=0;
float camx=0, camy=0, camz=100000;
float vertx=0, verty=1, vertz=0;
double ballex=0, balley=0, ballez=-5;
double ballevx=0, ballevy=0, ballevz=0;
float palettegy;
double palettegvy=0.00;
float palettedy;
double palettedvy=0.00;
int i,j=0;
int mode=1, choix=0, forme=0, son=1;
int sourisx, sourisy;
int refresh;
int mouv=10;
char victoire[10];
char * victoire01;
char * victoire02;
char * victoire03;
char * victoire04;
char * victoire05;
char score[13];
char score01[10]="0";
char meilleursscores[17];
char * meilleurscore01;
char * meilleurscore02;
char * meilleurscore03;
int arret=0;
int points=3;
int fps;
#ifdef SWIN32
	LONGLONG lastTime=0;
	LONGLONG currentTime;
	LONGLONG lastTime2=0;
	LONGLONG currentTime2;
	LONGLONG frequence;
#endif
#ifdef SLINUX
	double lastTime=0;
	double currentTime;
	double lastTime2=0;
	double currentTime2;
#endif
int swapfini=0;
int options=0, menuquit=0, credits=0, menudifficulte=0, reseau=0, menuip=0, menureseau=0;
int vsync, sourisactive, sensibilitesouris, fer, accballe, inertie, reso_1024, pasmusique, pasbruitage, barredespace, accballereseau=0;
int langue;
int choixia;
int ajoutpoint;
Mix_Music * son_jeu;
Mix_Music * son_menu;
Mix_Chunk * son_3;
Mix_Chunk * son_4;
Mix_Chunk * son_5;
Mix_Chunk * son_fly;
Mix_Chunk * son_beep1;
int reso, win, etat, infos=0, inputline=1;
int inichars[256];
int inichars2[256];
unsigned char *pseudo;
unsigned char *ip;
unsigned char *chatboxtext;
unsigned char *newgametext;
unsigned char nomserveur[31];

struct messagechatbox chatbox[12];
struct liste_utilisateurs utilisateurs[10];
struct liste_parties parties[5];

/******************************\DECLARATIONS ET INITIALISATIONS*******************************/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
/*********************************************************************************************/
/******                              FONCTION PRINCIPALE                                ******/
/******                              -------------------                                ******/
/******    lirefichier : charge les options  partir du fichier cfg                     ******/
/******    glutInit : initialisation de GLUT                                            ******/
/******    glutInitDisplayMode : initialisation de l'affichage (double buffering)       ******/
/******    glutInitWindowSize : indiquera la taille d'un ventuel mode fentr          ******/
/******    glutCreateWindow : titre de la fentre d'un ventuel mode fentr            ******/
/******    glutGameModString : dfini la rsolution et le refresh                       ******/
/******    glutEnterGameMode : active le mode "fullscreen"                              ******/
/******    glutMainLoop : permet d'entrer dans la boucle d'venements GLUT et de grer  ******/
/******                   les "callbacks" (appels des fonctions ci-dessus)              ******/
/******                                                                                 ******/
/*********************************************************************************************/

int main(int argc, char *argv[])
{
	lirefichier();
	
	lireini();
	
	if(langue == 0) //fr
	{
		strcpy(victoire, "Victoires");
		strcpy(score, "Score actuel");
		strcpy(meilleursscores, "Meilleurs scores");
	}
	else if(langue == 1) //en
	{
		strcpy(victoire, "Victories");
		strcpy(score, "Current score");
		strcpy(meilleursscores, "Best scores");
	}
	
	pseudo=(unsigned char*)malloc(sizeof(unsigned char));
	pseudo[0]='\0';
	ip=(unsigned char*)malloc(sizeof(unsigned char));
	ip[0]='\0';
	chatboxtext=(unsigned char*)malloc(sizeof(unsigned char));
	chatboxtext[0]='\0';
	newgametext=(unsigned char*)malloc(sizeof(unsigned char));
	newgametext[0]='\0';

	for(i=0;i<12;i++)
	{
		chatbox[i].message=(unsigned char*)malloc(sizeof(unsigned char));
		chatbox[i].message[0]='\0';
		chatbox[i].pseudo[0]='\0';
	}

	for(i=0;i<10;i++)
	{
		utilisateurs[i].etat=0;
		utilisateurs[i].pseudo[0]='\0';
	}

	for(i=0;i<5;i++)
	{
		parties[i].nom[0]='\0';
		parties[i].acceleration=0;
		parties[i].joueur1[0]='\0';
		parties[i].joueur2[0]='\0';
		parties[i].point1=0;
		parties[i].point2=0;
		parties[i].inertie1=0;
		parties[i].inertie2=0;
	}
	strcpy((char*)parties[0].nom, "Partie 1 : Pour les meilleurs");
	strcpy((char*)parties[1].nom, "Partie geniale, bien pratique");
	strcpy((char*)parties[2].nom, "Partie de debutants");
//	strcpy((char*)parties[3].nom, "On s'emmerde ici");
	strcpy((char*)parties[4].nom, "Hehe");
	strcpy((char*)parties[4].joueur1, "CRAzy-flaSH");
	strcpy((char*)parties[4].joueur2, "T-Storm");
	parties[4].point1=5;
	parties[4].point2=5;
	parties[4].inertie1=1;
	parties[4].inertie2=1;
	parties[4].acceleration=1;
	strcpy((char*)parties[1].joueur1, "Pucca");
	strcpy((char*)parties[1].joueur2, "Pica");

	for(i=0;i<10;i++)utilisateurs[i].etat=1;
	strcpy((char*)utilisateurs[0].pseudo,"CRAzy-flaSH");
	strcpy((char*)utilisateurs[1].pseudo,"Thunder-Storm");
	strcpy((char*)utilisateurs[2].pseudo,"D@mbe");
	strcpy((char*)utilisateurs[3].pseudo,"Owix");
	strcpy((char*)utilisateurs[4].pseudo,"Cheplus");
//	strcpy((char*)utilisateurs[5].pseudo,"Skull");
	utilisateurs[5].etat=0;
	strcpy((char*)utilisateurs[6].pseudo,"Bill Gates");
	strcpy((char*)utilisateurs[7].pseudo,"Maverick");
	strcpy((char*)utilisateurs[8].pseudo,"THeTiTeuF");
	strcpy((char*)utilisateurs[9].pseudo,"Pucca");

	triparties();
	triutilisateurs();

	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);

	glutInitWindowSize(512,256);
	win=glutCreateWindow("PonGL : choix de rsolution");
	
	// initialize SDL for audio and video
	if(SDL_Init(SDL_INIT_AUDIO)<0)
		cleanExit("SDL_Init");
	
	refresh=85;

	init2();
	
	glutMainLoop();

	return 0;
}

/************************************\FONCTION PRINCIPALE*************************************/
