#include "savefile.h"

/*********************************************************************************************/
/******             FONCTIONS DE LECTURE ET D'ENREGISTREMENT DES PREFERENCES            ******/
/******             --------------------------------------------------------            ******/
/******    Ces fonctions permettent de lire et d'enregistrer dans le fichier contenant  ******/
/******    les prfrences (options selectionnes) et les meilleurs scores du jeu.      ******/
/******                                                                                 ******/
/******    temp[50] : permet de stocker les infos inutiles lors de la lecture de        ******/
/******               fichiers.                                                         ******/
/******                                                                                 ******/
/*********************************************************************************************/

void enregistrerfichier()
{
	FILE * fichier;
	fichier = fopen("data/pglconfig.cfg", "w");
	fprintf(fichier, "%d (Synchronisation verticale)\n", vsync);
	fprintf(fichier, "%d (Activation souris)\n", sourisactive);
	fprintf(fichier, "%d (Sensibilit souris : 1-100)\n", sensibilitesouris);
	fprintf(fichier, "%d (Fil de fer)\n", fer);
	fprintf(fichier, "%d (Acclration de la balle)\n", accballe);
	fprintf(fichier, "%d (Inertie des palettes)\n", inertie);
	fprintf(fichier, "%d (Rsolution : 1024*768)\n", reso_1024);
	fprintf(fichier, "%d (Pas de musique)\n", pasmusique);
	fprintf(fichier, "%d (Pas de bruitages)\n", pasbruitage);
	fprintf(fichier, "%d (Barre d'espace)\n", barredespace);
	fprintf(fichier, "%d (Langue)\n", langue);
	fprintf(fichier, "%s (Victoires I CAN WIN)\n", victoire01);
	fprintf(fichier, "%s (Victoires BRING IT ON)\n", victoire02);
	fprintf(fichier, "%s (Victoires HURT ME PLENTY)\n", victoire03);
	fprintf(fichier, "%s (Victoires HARDCORE)\n", victoire04);
	fprintf(fichier, "%s (Victoires NIGHTMARE)\n", victoire05);
	fprintf(fichier, "%s (Meilleur score 01)\n", meilleurscore01);
	fprintf(fichier, "%s (Meilleur score 02)\n", meilleurscore02);
	fprintf(fichier, "%s (Meilleur score 03)\n", meilleurscore03);
	fclose(fichier);
}

int numofline(char * line)
{
	int i;
	char * number;
	number = (char*)malloc(15*sizeof(char));
	
	for(i=0;line[i]!=' ';i++)
		number[i] = line[i];
	
	number[i]='\0';
	
	return  atoi(number); 
}


char * textofline(char * line)
{
	int i;
	char * number;
	number = (char*)malloc(15*sizeof(char));
	
	for(i=0;line[i]!=' ';i++)
		number[i] = line[i];
		
	number[i]='\0';
	
	return number; 
}

void lirefichier(char * line)
{
	char * buffer;
	FILE * fichier;
	
	buffer = (char*)malloc(100*sizeof(char));
		
	fichier = fopen("data/pglconfig.cfg", "r");
	if(fichier!=NULL)
	{
		// Acclration verticale
		fgets(buffer, 100, fichier);
		vsync=numofline(buffer);
		
		// Activation souris
		fgets(buffer, 100, fichier);
		sourisactive=numofline(buffer);
		
		// Sensibilit de la souris
		fgets(buffer, 100, fichier);
		sensibilitesouris=numofline(buffer);
		
		// Fil de fer
		fgets(buffer, 100, fichier);
		fer=numofline(buffer);
		
		// Acclration de la balle
		fgets(buffer, 100, fichier);
		accballe=numofline(buffer);
		
		// inertie
		fgets(buffer, 100, fichier);
		inertie=numofline(buffer);
		
		// Plein cran
		fgets(buffer, 100, fichier);
		reso_1024=numofline(buffer);
		
		// Pas de musique
		fgets(buffer, 100, fichier);
		pasmusique=numofline(buffer);
		
		// Pas de bruitages
		fgets(buffer, 100, fichier);
		pasbruitage=numofline(buffer);
		
		// Barre d'espace pour lancer la balle
		fgets(buffer, 100, fichier);
		barredespace=numofline(buffer);
		
		// Langue
		fgets(buffer, 100, fichier);
		langue=numofline(buffer);
		
		// nombre de victoires en niveau 1
		fgets(buffer, 100, fichier);
		victoire01=textofline(buffer);
		
		// nombre de victoires en niveau 2
		fgets(buffer, 100, fichier);
		victoire02=textofline(buffer);
		
		// nombre de victoires en niveau 3
		fgets(buffer, 100, fichier);
		victoire03=textofline(buffer);
		
		// nombre de victoires en niveau 4
		fgets(buffer, 100, fichier);
		victoire04=textofline(buffer);
		
		// nombre de victoires en niveau 5
		fgets(buffer, 100, fichier);
		victoire05=textofline(buffer);
		
		// Meilleure score solo 1
		fgets(buffer, 100, fichier);
		meilleurscore01=textofline(buffer);
		
		// Meilleure score solo 2
		fgets(buffer, 100, fichier);
		meilleurscore02=textofline(buffer);
		
		// Meilleure score solo 3
		fgets(buffer, 100, fichier);
		meilleurscore03=textofline(buffer);

		fclose(fichier);
	}
	else
	{
		vsync=0;
		sourisactive=1;
		sensibilitesouris = 50;
		fer=0;
		accballe=1;
		inertie=1;
		reso_1024=0;
		pasmusique=0;
		pasbruitage=0;
		barredespace=0;
		langue=0; // franais
		victoire01 = (char*)malloc(5*sizeof(char));
		victoire02 = (char*)malloc(5*sizeof(char));
		victoire03 = (char*)malloc(5*sizeof(char));
		victoire04 = (char*)malloc(5*sizeof(char));
		victoire05 = (char*)malloc(5*sizeof(char));
		meilleurscore01 = (char*)malloc(10*sizeof(char));
		meilleurscore02 = (char*)malloc(10*sizeof(char));
		meilleurscore03 = (char*)malloc(10*sizeof(char));
		strcpy(victoire01, "0");
		strcpy(victoire02, "0");
		strcpy(victoire03, "0");
		strcpy(victoire04, "0");
		strcpy(victoire05, "0");
		strcpy(meilleurscore01, "0");
		strcpy(meilleurscore02, "0");
		strcpy(meilleurscore03, "0");
	
		enregistrerfichier();
	}
	
	free(buffer);
}

/******************\FONCTIONS DE LECTURE ET D'ENREGISTREMENT DES PREFERENCES******************/

void lireini()
{
	int i;

	FILE * fichier;
	fichier=fopen("data/ascii1.ini", "r");
	for(i=0;i<256;i++)
	{
		fscanf(fichier, "%d", &inichars[i]);
	}
	fclose(fichier);

	fichier=fopen("data/ascii2.ini", "r");
	for(i=0;i<256;i++)
	{
		fscanf(fichier, "%d", &inichars2[i]);
	}
	fclose(fichier);
}

